#!/bin/bash
#----------------------------------------------------------------------------
# /usr/share/asterisk/agi-bin/callback.sh
#
# Creation:     2004-11-19  fw
# Last Update:  $Id: callback.sh 8393 2015-02-16 21:50:50Z holbru $
#
# Copyright (c) 2004-2005 Fabian Wolter, fabian(at)eisfair(dot)org
# Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#----------------------------------------------------------------------------

callpath="/var/spool/asterisk/tmp/"
callfile=$callpath"call`date +%Y%m%d_%H%M%S`"
date=`date +%Y%m%d-%H%M%S`
logfile=/var/log/asterisk/callback

. /etc/config.d/asterisk

mkdir -p $callpath
i=0

read -a name

while [ "${name[0]}" != "agi_callerid:" ]
do
  read -a name
  i=`expr $i + 1`
  if [ $i -ge 20 ] ; then
   break
  fi
done

if [ "${name[0]}" = "agi_callerid:" ] ; then

    callerid=`echo ${name[1]} | sed 's/+//g'`

    if [ "$ASTERISK_CALLBACK_GLOBAL_PIN" != "" ]
    then
        pin=$ASTERISK_CALLBACK_GLOBAL_PIN
        allowed=true
    else
        idx=1
        while [ $idx -le $ASTERISK_CALLBACK_ALLOW_N ]
        do
            eval cid='$ASTERISK_CALLBACK_ALLOW_'$idx'_CALLERID'
            eval pin='$ASTERISK_CALLBACK_ALLOW_'$idx'_PIN'

            if [ "$callerid" = "$cid" ]
            then
                allowed=true
                break
            fi

            idx=`expr $idx + 1`
        done
    fi

    if [ "$allowed" = "true" ]
    then
        echo "`date`: accepting incoming call from '$callerid'!" >> $logfile

        touch $callfile
        echo "Channel: Local/$callerid@callback-dial" >> $callfile
        echo "Callerid: $callerid"                    >> $callfile
        echo "Context: callback-go"                   >> $callfile
        echo "Extension: s"                           >> $callfile
        echo "MaxRetries: 1"                          >> $callfile
        echo "RetryTime: 5"                           >> $callfile
        echo "WaitTime: 15"                           >> $callfile
        echo "Set: password=$pin"                     >> $callfile

        mv $callfile /var/spool/asterisk/outgoing
    else
        echo "`date`: incoming call from '$callerid' rejected!"      >> $logfile
    fi

fi
