#!/bin/sh
#------------------------------------------------------------------------------
# /var/install/config.d/asterisk.update.sh - Configuration file generation
#
# Creation:     2004-11-19 fw
# Last Update:  $Id: asterisk-update.sh 9394 2017-07-11 11:06:18Z holbru $
#
# Copyright (c) 2004-2005 Fabian Wolter, fabian(at)eisfair(dot)org
# Copyright (c) 2012-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------

package_name=asterisk

# include configlib
. /var/install/include/configlib


#exec 2>/tmp/asterisk-update-tarce$$.log
#set -x

version=$(grep "<version" /var/install/packages/${package_name} |
         sed 's# ##g; s#</*version>##g')

# ---------------------------------------------------------------------------
# Set the default values for configuration
# ---------------------------------------------------------------------------
START_ASTERISK='no'

ASTERISK_CONFIG_USE='yes'
ASTERISK_LOAD_CAPI='no'
ASTERISK_LOAD_DAHDI='no'
ASTERISK_LOG_INTO_FILE='no'

ASTERISK_LANGUAGE='de'
ASTERISK_CODECS='ulaw'
ASTERISK_ADVANCED_ERROR_MSG='no'
ASTERISK_AREA_CODE=''
ASTERISK_RECORD_CONVERSATION='no'



ASTERISK_HFCS_GROUP_N='2'
ASTERISK_HFCS_GROUP_1_ACTIVE='no'
#ASTERISK_HFCS_GROUP_1_TYPE='zaphfc'
ASTERISK_HFCS_GROUP_1_PROVIDE_S0_BUS='yes'
ASTERISK_HFCS_GROUP_1_PTP='no'
ASTERISK_HFCS_GROUP_1_PORTS='1'
ASTERISK_HFCS_GROUP_2_ACTIVE='no'
ASTERISK_HFCS_GROUP_2_TYPE='multi'
ASTERISK_HFCS_GROUP_2_PROVIDE_S0_BUS='no'
ASTERISK_HFCS_GROUP_2_PTP='yes'
ASTERISK_HFCS_GROUP_2_PORTS='4'


ASTERISK_FX_GROUP_N='3'
ASTERISK_FX_GROUP_1_ACTIVE='no'
ASTERISK_FX_GROUP_1_TYPE='fxo'
ASTERISK_FX_GROUP_1_PORTS='1'
ASTERISK_FX_GROUP_2_ACTIVE='no'
ASTERISK_FX_GROUP_2_TYPE='none'
ASTERISK_FX_GROUP_2_PORTS='2'
ASTERISK_FX_GROUP_3_ACTIVE='no'
ASTERISK_FX_GROUP_3_TYPE='fxs'
ASTERISK_FX_GROUP_3_PORTS='1'


ASTERISK_WEBINTERFACE_START='no'
ASTERISK_WEBINTERFACE_FORCE_SSL='yes'
ASTERISK_WEBINTERFACE_CERTIFICATE=''
ASTERISK_WEBINTERFACE_N='1'
ASTERISK_WEBINTERFACE_1_USER='root'
ASTERISK_WEBINTERFACE_1_PASSWD='ruth'


ASTERISK_SIP_PORT='5060'
ASTERISK_RTP_PORTS='10000-20000'
ASTERISK_LOCALNETS_N='1'
ASTERISK_LOCALNETS_1_NAME=''
ASTERISK_LOCALNETS_1_ACTIVE='yes'
ASTERISK_LOCALNETS_1_IP='192.168.0.0/24'
ASTERISK_LISTEN_ADDR='192.168.0.10'
ASTERISK_EXTERNIP='mysubdomain.eisfair.net'


ASTERISK_DIALPREFIX_SIP=''
ASTERISK_DIALPREFIX_IAX='111'
ASTERISK_DIALPREFIX_CAPI='000'
ASTERISK_DIALPREFIX_INTERNAL='*'
ASTERISK_DIALPREFIX_VBOX='#9'
ASTERISK_DIALPREFIX_DISA='8'

ASTERISK_DIALPREFIX_SHOW_CAPI='no'
ASTERISK_DIALPREFIX_SHOW_SIP='no'
ASTERISK_DIALPREFIX_SHOW_IAX='no'


ASTERISK_VMAIL_FROM_ADDR='asterisk-mailbox@fabian-wolter.de'
ASTERISK_VMAIL_FROM_NAME='Asterisk Voicemailbox'
ASTERISK_VBOX_MAX_MSG_LENGTH='180'
ASTERISK_VBOX_PLAY_INSTRUCTIONS='yes'
ASTERISK_VBOX_AUTODETECT_CID='no'


ASTERISK_RESOLVE_NUMBERS='no'
ASTERISK_RESOLVE_NUMBERS_REMOTE='yes'
ASTERISK_RESOLVE_NUMBERS_SOURCE='file'
ASTERISK_RESOLVE_NUMBERS_PATH='/public/phonelist.txt'
ASTERISK_RESOLVE_NUMBERS_DB_HOST='localhost'
ASTERISK_RESOLVE_NUMBERS_DB_USER='asterisk'
ASTERISK_RESOLVE_NUMBERS_DB_PASS='topsecret'
ASTERISK_RESOLVE_NUMBERS_DB_NAME='asterisk'
ASTERISK_RESOLVE_NUMBERS_DB_TABLE='phonebook'


ASTERISK_SIP_QUALIFY='no'
ASTERISK_SIP_N='2'
ASTERISK_SIP_1_ACTIVE='no'
ASTERISK_SIP_1_NAME='t-online'
ASTERISK_SIP_1_USER='032999999:emailpref'
ASTERISK_SIP_1_PASSWORD='not2knew4u'
ASTERISK_SIP_1_HOST='tel.t-online.de'
ASTERISK_SIP_1_CALLERID='032999999'
ASTERISK_SIP_1_FALLBACK='sip:gmx capi:123456'
ASTERISK_SIP_1_EXEC_ON_RING=''
ASTERISK_SIP_1_VBOX='no'
ASTERISK_SIP_1_VBOX_NUMBER='22222'
ASTERISK_SIP_1_VBOX_ANSWER_AFTER='10'
ASTERISK_SIP_1_REDIRECT_SCHEME=''


ASTERISK_SIP_2_ACTIVE='no'
ASTERISK_SIP_2_NAME='gmx'
ASTERISK_SIP_2_USER='4951112345678'
ASTERISK_SIP_2_PASSWORD='not2knew4u'
ASTERISK_SIP_2_HOST='sip-gmx.de'
ASTERISK_SIP_2_CALLERID='4951112345678'
ASTERISK_SIP_2_FALLBACK='iax:voipbuster'
ASTERISK_SIP_2_EXEC_ON_RING=''
ASTERISK_SIP_2_VBOX='no'
ASTERISK_SIP_2_VBOX_NUMBER=''
ASTERISK_SIP_2_VBOX_ANSWER_AFTER=''
ASTERISK_SIP_2_REDIRECT_SCHEME=''


ASTERISK_IAX_QUALIFY='no'
ASTERISK_IAX_N='1'
ASTERISK_IAX_1_ACTIVE='no'
ASTERISK_IAX_1_NAME='voipbuster'
ASTERISK_IAX_1_USER='myusername'
ASTERISK_IAX_1_PASSWORD='not2knew4u'
ASTERISK_IAX_1_HOST='iax.voipbuster.com'
ASTERISK_IAX_1_CALLERID='123456'
ASTERISK_IAX_1_FALLBACK='sip:gmx capi:123456'
ASTERISK_IAX_1_EXEC_ON_RING=''
ASTERISK_IAX_1_VBOX='no'
ASTERISK_IAX_1_VBOX_NUMBER=''
ASTERISK_IAX_1_VBOX_ANSWER_AFTER=''
ASTERISK_IAX_1_REDIRECT_SCHEME=''



ASTERISK_PHONES_N='2'
ASTERISK_PHONES_1_ACTIVE='no'
ASTERISK_PHONES_1_MSN='10'
ASTERISK_PHONES_1_TYPE='hfcs'
ASTERISK_PHONES_1_MAC_ADDR='00AABBCCDDEEFF11'
ASTERISK_PHONES_1_PIN='7710'
ASTERISK_PHONES_1_RING_ON_SIP='sipgate gmx'
ASTERISK_PHONES_1_RING_ON_IAX=''
ASTERISK_PHONES_1_RING_ON_CAPI='11111 22222'
ASTERISK_PHONES_1_OUTGOING_NAME='Wolter Tel1'
ASTERISK_PHONES_1_OUTGOING_SIP='sipgate'
ASTERISK_PHONES_1_OUTGOING_IAX='voipbuster'
ASTERISK_PHONES_1_OUTGOING_MSN='11111'
ASTERISK_PHONES_1_OUTGOING_HFCS_GROUP=''
ASTERISK_PHONES_1_EXEC_ON_RINGVV=''
ASTERISK_PHONES_1_NETBIOS_NAME=''
ASTERISK_PHONES_1_LCR='yes'
ASTERISK_PHONES_1_VBOX='no'
ASTERISK_PHONES_1_VBOX_MAIL='vbox10@fabian-wolter.de'
ASTERISK_PHONES_1_VBOX_ANSWER_AFTER='15'
ASTERISK_PHONES_2_ACTIVE='no'
ASTERISK_PHONES_2_MSN='11'
ASTERISK_PHONES_2_TYPE='sip'
ASTERISK_PHONES_2_MAC_ADDR='00AABBCCDDEEFF11'
ASTERISK_PHONES_2_PIN='7711'
ASTERISK_PHONES_2_RING_ON_SIP='sipgate'
ASTERISK_PHONES_2_RING_ON_IAX=''
ASTERISK_PHONES_2_RING_ON_CAPI='22222 33333'
ASTERISK_PHONES_2_OUTGOING_NAME='Wolter Tel2'
ASTERISK_PHONES_2_OUTGOING_SIP='sipgate'
ASTERISK_PHONES_2_OUTGOING_IAX='voipbuster'
ASTERISK_PHONES_2_OUTGOING_MSN='33333'
ASTERISK_PHONES_2_OUTGOING_HFCS_GROUP=''
ASTERISK_PHONES_2_EXEC_ON_RING=''
ASTERISK_PHONES_2_NETBIOS_NAME=''
ASTERISK_PHONES_2_LCR='yes'
ASTERISK_PHONES_2_VBOX='no'
ASTERISK_PHONES_2_VBOX_MAIL='vbox11@fabian-wolter.de'
ASTERISK_PHONES_2_VBOX_ANSWER_AFTER='15'


ASTERISK_MSN_N='1'
ASTERISK_MSN_1_ACTIVE='no'
ASTERISK_MSN_1_NUMBER='12345678'
ASTERISK_MSN_1_EXEC_ON_RING=''
ASTERISK_MSN_1_VBOX='yes'
ASTERISK_MSN_1_VBOX_NUMBER='22222'
ASTERISK_MSN_1_VBOX_ANSWER_AFTER='9'
ASTERISK_MSN_1_REDIRECT_SCHEME='1'


ASTERISK_VBOX_N='2'
ASTERISK_VBOX_1_ACTIVE='no'
ASTERISK_VBOX_1_NUMBER='22222'
ASTERISK_VBOX_1_PIN='1234'
ASTERISK_VBOX_1_OWNER_NAME='Fabian Wolter'
ASTERISK_VBOX_1_MAIL='vbox22222@fabian-wolter.de'
ASTERISK_VBOX_1_NOTIFY_N='2'
ASTERISK_VBOX_1_NOTIFY_1_ACTIVE='no'
ASTERISK_VBOX_1_NOTIFY_1_PHONE='10'
ASTERISK_VBOX_1_NOTIFY_2_ACTIVE='no'
ASTERISK_VBOX_1_NOTIFY_2_PHONE='11'

ASTERISK_VBOX_2_ACTIVE='no'
ASTERISK_VBOX_2_NUMBER='33333'
ASTERISK_VBOX_2_PIN='4321'
ASTERISK_VBOX_2_OWNER_NAME='Otto Normaluser'
ASTERISK_VBOX_2_MAIL='vbox33333@fabian-wolter.de'
ASTERISK_VBOX_2_NOTIFY_N='1'
ASTERISK_VBOX_2_NOTIFY_1_ACTIVE='no'
ASTERISK_VBOX_2_NOTIFY_1_PHONE='11'


ASTERISK_REDIRECT_N='1'
ASTERISK_REDIRECT_1_ACTIVE='no'
ASTERISK_REDIRECT_1_SCHEME_N='2'
ASTERISK_REDIRECT_1_SCHEME_1_EXECUTE_AFTER='10'
ASTERISK_REDIRECT_1_SCHEME_1_EXECUTE_BETWEEN_N='2'
ASTERISK_REDIRECT_1_SCHEME_1_EXECUTE_BETWEEN_1_TIME='9:00-12:00|mon-fri|*|Dec'
ASTERISK_REDIRECT_1_SCHEME_1_EXECUTE_BETWEEN_2_TIME='13:00-18:00|mon-fri|*|Dec'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_N='4'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_1_TYPE='capi'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_1_ADDR='1234567'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_1_FROM='98765'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_2_TYPE='hfcs1'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_2_ADDR='654321'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_2_FROM='98765'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_3_TYPE='internal'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_3_ADDR='10'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_3_FROM=''
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_4_TYPE='sip'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_4_ADDR='87654'
ASTERISK_REDIRECT_1_SCHEME_1_TARGET_4_FROM='sipgate'

ASTERISK_REDIRECT_1_SCHEME_2_EXECUTE_AFTER='10'
ASTERISK_REDIRECT_1_SCHEME_2_EXECUTE_BETWEEN_N='1'
ASTERISK_REDIRECT_1_SCHEME_2_EXECUTE_BETWEEN_1_TIME='*|sat-sun|*|Dec'
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_N='2'
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_1_TYPE='vbox'
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_1_ADDR='10'
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_1_FROM=''
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_2_TYPE='vbox'
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_2_ADDR='98765'
ASTERISK_REDIRECT_1_SCHEME_2_TARGET_2_FROM=''


ASTERISK_LCR='no'
ASTERISK_LCR_CRON='13 4 * * *'


ASTERISK_IVR_N='1'
ASTERISK_IVR_1_ACTIVE='no'
ASTERISK_IVR_1_NUMBER='#200'
ASTERISK_IVR_1_INSTRUCTIONS='demo-thanks'
ASTERISK_IVR_1_ENTRY_N='2'
ASTERISK_IVR_1_ENTRY_1_NUMBER='1'
ASTERISK_IVR_1_ENTRY_1_TYPE='dial'
ASTERISK_IVR_1_ENTRY_1_VALUE='*10'
ASTERISK_IVR_1_ENTRY_2_NUMBER='3'
ASTERISK_IVR_1_ENTRY_2_TYPE='exec'
ASTERISK_IVR_1_ENTRY_2_VALUE='echo "User pressed 3" >/var/log/asterisk/ivr.log'


ASTERISK_START_TAPI='no'
ASTERISK_TAPI_PORT='5038'
ASTERISK_TAPI_USER_N='1'
ASTERISK_TAPI_USER_1_NAME='fab'
ASTERISK_TAPI_USER_1_PASS='not2knew4u'
ASTERISK_TAPI_USER_1_ACCESS='192.168.0.0/24'


ASTERISK_CALLTHROUGH_N='1'
ASTERISK_CALLTHROUGH_1_ACTIVE='no'
ASTERISK_CALLTHROUGH_1_MSN='123456'
ASTERISK_CALLTHROUGH_1_OUTGOING_SIP='sipgate'
ASTERISK_CALLTHROUGH_1_OUTGOING_IAX='voipbuster'
ASTERISK_CALLTHROUGH_1_OUTGOING_MSN='123456'
ASTERISK_CALLTHROUGH_1_OUTGOING_HFCS_GROUP=''
ASTERISK_CALLTHROUGH_1_ALLOW_SIP='no'
ASTERISK_CALLTHROUGH_1_ALLOW_IAX='no'
ASTERISK_CALLTHROUGH_1_ALLOW_CAPI='no'
ASTERISK_CALLTHROUGH_1_ALLOW_N='0'
ASTERISK_CALLTHROUGH_1_ALLOW_1_ACTIVE='no'
ASTERISK_CALLTHROUGH_1_ALLOW_1_CALLERID='0511789456'
ASTERISK_CALLTHROUGH_1_ALLOW_1_PIN='1234'
ASTERISK_CALLTHROUGH_1_ANONYMOUS_ACCESS='yes'
ASTERISK_CALLTHROUGH_1_ANONYMOUS_PIN='4321'


ASTERISK_CALLBACK='no'
ASTERISK_CALLBACK_LISTEN_NUMBER='12345678'
ASTERISK_CALLBACK_OUTGOING_TYPE='capi'
ASTERISK_CALLBACK_OUTGOING_FROM='12345678'
ASTERISK_CALLBACK_GLOBAL_PIN=''
ASTERISK_CALLBACK_ALLOW_N='1'
ASTERISK_CALLBACK_ALLOW_1_CALLERID='051187654321'
ASTERISK_CALLBACK_ALLOW_1_PIN='1234'


# ---------------------------------------------------------------------------
# rename old variables
# ---------------------------------------------------------------------------
rename_old_variables ()
{
    # read old values
    if [ -f /etc/config.d/${package_name} ]
    then
        /var/install/bin/backup-file --quiet ${package_name}
        . /etc/config.d/${package_name}
    fi
}

# --------------------------------------------------------------------------
# Write config and default files
# --------------------------------------------------------------------------
make_config_file()
{
    internal_conf_file=${1}
    {
    # ----------------------------------------------------------------------
    printgpl --conf ${package_name} "2004-11-06" "fw" "2012-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net"
    # ----------------------------------------------------------------------
    echo "# Asterisk-VERSION ${version}"
    # ----------------------------------------------------------------------
    printgroup "General settings"
    # ----------------------------------------------------------------------

    printvar "START_ASTERISK"
    printcomment            "Start asterisk at boot time?"

    # begin ASTERISK_CONFIG_USE -> no
    # show only the next 4 paramter

    printvar 'ASTERISK_CONFIG_USE'
    printcomment            "'yes' default, use this config"
    printcomment            "'no' I configure asterisk by hand"
    printvar "ASTERISK_LOAD_CAPI"
    printcomment            "Load CAPI modules at startup?"

    if [ -n "${ASTERISK_LOAD_HFCS}" ]
    then
        ASTERISK_LOAD_DAHDI="${ASTERISK_LOAD_HFCS}"
    fi

    printvar "ASTERISK_LOAD_DAHDI"
    printcomment            "Load Dahdi modules at up?"
    printvar "ASTERISK_LOG_INTO_FILE"
    printcomment            "Verbose log (very fast growing logfile!)"

    # end ASTERISK_CONFIG_USE -> no

    printvar "ASTERISK_LANGUAGE"
    printcomment            "Language for the announcements (VBOX, etc.)"
    printvar "ASTERISK_CODECS"
    printcomment            "e.g. 'ulaw' for dsl users, 'gsm' for ISDN users"
    printvar "ASTERISK_ADVANCED_ERROR_MSG"
    printcomment            "Speak advanced error message, "
    printcomment            "when dialing a wrong number"
    printvar "ASTERISK_AREA_CODE"
    printcomment            "Number will be set before the dialed number for"
    printcomment            "outgoing SIP calls without leading 0"
    printvar "ASTERISK_RECORD_CONVERSATION"
    printcomment            "record all telephone conversations"


    # -----------------------------------------------------------------------
    printgroup "HFC-S ISDN controller settings"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_HFCS_GROUP_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_HFCS_GROUP_N}" ]
    do
        printvar "ASTERISK_HFCS_GROUP_${idx}_ACTIVE"
#        printvar "ASTERISK_HFCS_GROUP_${idx}_TYPE"
#        printcomment        "'zaphfc' for normal HFCS card or multi "
#        printcomment        "for double or quad port cards"
        printvar "ASTERISK_HFCS_GROUP_${idx}_PROVIDE_S0_BUS"
        printcomment        "'yes' if you want to connect other phones to"
        printcomment        "this port. 'no' if you connect this port to"
        printcomment        "your phone company"
        printvar "ASTERISK_HFCS_GROUP_${idx}_PTP"
        printcomment        "if the port is connected to your phone company"
        printcomment        "and you have a Point-to-Point (Anlagenanschluss)"
        printcomment        "connection, set this to yes"
        printvar "ASTERISK_HFCS_GROUP_${idx}_PORTS"
        printcomment        "How many RJ45 ports belong to this group"
        printcomment        "(may be spreaded over serveral cards)"
        #echo "ASTERISK_HFCS_GROUP_${idx}_BCHANNELS"  $bchans'        # B channels per Port"

        echo
        idx=$(expr $idx + 1)
    done

    # -----------------------------------------------------------------------
    printgroup "Analogue interface settings (FXO/FXS)"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_FX_GROUP_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_FX_GROUP_N}" ]
    do
        printvar "ASTERISK_FX_GROUP_${idx}_ACTIVE"
        printvar "ASTERISK_FX_GROUP_${idx}_TYPE"
        printcomment        "fxs: connected to a telephone;"
        printcomment        "fxo: connected to the phone company;"
        printcomment        "none: slot empty"
        printvar "ASTERISK_FX_GROUP_${idx}_PORTS"
        printcomment        "number of sockets which belongs to this group"

        echo
        idx=$( expr $idx + 1 )
    done


    # -----------------------------------------------------------------------
    printgroup "Asterisk Webinterface"
    # -----------------------------------------------------------------------

    printvar 'ASTERISK_WEBINTERFACE_START'
    printcomment            'start the webinterface when asterisk starts'
    printvar 'ASTERISK_WEBINTERFACE_FORCE_SSL'
    printcomment            "'yes' -> use https with SSL, default, recommended"
    printcomment            "'no' -> use http without SSL, not recommended "
    printvar 'ASTERISK_WEBINTERFACE_CERTIFICATE'
    printcomment            'Name from ssl server certificate'

    printvar "ASTERISK_WEBINTERFACE_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_WEBINTERFACE_N}" ]
    do
        printvar "ASTERISK_WEBINTERFACE_${idx}_USER"   "username to login"
        printvar "ASTERISK_WEBINTERFACE_${idx}_PASSWD" "password to login"

        echo
        idx=$( expr $idx + 1 )
    done


    # -----------------------------------------------------------------------
    printgroup "Network settings"
    # -----------------------------------------------------------------------

    printvar 'ASTERISK_SIP_PORT'
    printcomment            'default: 5060'
    printvar 'ASTERISK_RTP_PORTS'
    printcomment            'RTP Ports forwarded to Asterisk'

    echo

    printvar 'ASTERISK_LOCALNETS_N'
    printcomment            'Number of localnets'

    if [ -n "${ASTERISK_LOCALNET}" ]
    then
         eval ASTERISK_LOCALNETS_1_IP='${ASTERISK_LOCALNET}'
         ASTERISK_LOCALNETS_1_ACTIVE='yes'
    fi

    idx=1
    while [ "${idx}" -le "${ASTERISK_LOCALNETS_N}" ]
    do
        printvar "ASTERISK_LOCALNETS_${idx}_NAME"
        printcomment        'It is only for you'
        printvar "ASTERISK_LOCALNETS_${idx}_ACTIVE"
        printcomment        'yes or no'
        printvar "ASTERISK_LOCALNETS_${idx}_IP"
        printcomment        'Masked net (NAT)'

        echo
        idx=$( expr $idx + 1 )
    done

    printvar "ASTERISK_LISTEN_ADDR"
    printcomment            "Only needed for Cisco IP phones"
    printvar "ASTERISK_EXTERNIP"
    printcomment            "IP-Address or domainname reachable"
    printcomment            "from the internet"

    # -----------------------------------------------------------------------
    printgroup "Dial prefixes"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_DIALPREFIX_SIP"
    printcomment            "... through SIP"
    printvar "ASTERISK_DIALPREFIX_IAX"
    printcomment            "... through IAX"
    printvar "ASTERISK_DIALPREFIX_CAPI"
    printcomment            "... through the convincial telephone network"
    printvar "ASTERISK_DIALPREFIX_INTERNAL"
    printcomment            "... an internal phone"
    printvar "ASTERISK_DIALPREFIX_VBOX"
    printcomment            "... a voicebox of an internal phone"
    printvar "ASTERISK_DIALPREFIX_DISA"
    printcomment            "MSN to listen to for callthrough"

    printvar "ASTERISK_DIALPREFIX_SHOW_CAPI"
    printcomment            "Show dialprefix in callerID of incoming"
    printcomment            "calls over CAPI"
    printvar "ASTERISK_DIALPREFIX_SHOW_SIP"
    printcomment            "Show dialprefix in callerID of incoming"
    printcomment            "calls over SIP"
    printvar "ASTERISK_DIALPREFIX_SHOW_IAX"
    printcomment            "Show dialprefix in callerID of incoming"
    printcomment            "calls over IAX"


    # -----------------------------------------------------------------------
    printgroup "Voicemail/Voicebox configuration"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_VMAIL_FROM_ADDR"
    printcomment            "email address which the recordings will be sent"
    printvar "ASTERISK_VMAIL_FROM_NAME"
    printcomment            "The name which appears in the From:-Fiel"
    printcomment            "in the email"
    printvar "ASTERISK_VBOX_MAX_MSG_LENGTH"
    printcomment            "After x sec. the recording aborts"
    printvar "ASTERISK_VBOX_PLAY_INSTRUCTIONS"
    printcomment            "Play 'Please leave your message after the tone'"
    printvar "ASTERISK_VBOX_AUTODETECT_CID"
    printcomment            "if set to yes, you only need to dial the vbox"
    printcomment            "dialprefix to listen to the vbox"

    # -----------------------------------------------------------------------
    printgroup "Telephone number reverse lookup"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_RESOLVE_NUMBERS"
    printcomment            "Do a reverse lookup for all inco"
    printcomment            "CAPI, SIP & IAX in the local phonebook"
    printvar "ASTERISK_RESOLVE_NUMBERS_REMOTE"
    printcomment            "If the number was not found in the local"
    printcomment            "phonebook search it at dasoertliche.de"
    printvar "ASTERISK_RESOLVE_NUMBERS_SOURCE"
    printcomment            "wether 'file' or 'db'"
    printvar "ASTERISK_RESOLVE_NUMBERS_PATH"
    printcomment            "If using 'file' enter the full path with filename"
    printvar "ASTERISK_RESOLVE_NUMBERS_DB_HOST"
    printcomment            "hostname of MySQL database"
    printvar "ASTERISK_RESOLVE_NUMBERS_DB_USER"
    printcomment            "username"
    printvar "ASTERISK_RESOLVE_NUMBERS_DB_PASS"
    printcomment            "password"
    printvar "ASTERISK_RESOLVE_NUMBERS_DB_NAME"
    printcomment            "name of the database"
    printvar "ASTERISK_RESOLVE_NUMBERS_DB_TABLE"
    printcomment            "name of the table to store the data"

    # -----------------------------------------------------------------------
    printgroup "SIP-Proxy configuration" "(e.g. at sipgate.de, GMX, 1&1 or web.de)"
    # -----------------------------------------------------------------------

    printvar 'ASTERISK_SIP_QUALIFY'
    printcomment            "'yes' Asterisk send pings to the other side"
    printcomment            "'no' default"


    printvar "ASTERISK_SIP_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_SIP_N}" ]
    do
        printvar "ASTERISK_SIP_${idx}_ACTIVE"
        printvar "ASTERISK_SIP_${idx}_NAME"
        printcomment        "Name of this SIP-Account"
        printvar "ASTERISK_SIP_${idx}_USER"
        printcomment        "User ID of this SIP-Account"
        printvar "ASTERISK_SIP_${idx}_PASSWORD"
        printcomment        "Password of this SIP-Account"
        printvar "ASTERISK_SIP_${idx}_HOST"
        printcomment        "Host of the SIP-Proxy"
        printvar "ASTERISK_SIP_${idx}_CALLERID"
        printcomment        "Used as caller id for outgoing calls"
        printvar "ASTERISK_SIP_${idx}_FALLBACK"
        printcomment        "If the account is down use those"
        printcomment        "(in the given order) instead"
        printvar "ASTERISK_SIP_${idx}_EXEC_ON_RING"
        printcomment        "Command to execute on ring"
        printvar "ASTERISK_SIP_${idx}_VBOX"
        printcomment        "Enable the vbox for this SIP account"
        printvar "ASTERISK_SIP_${idx}_VBOX_NUMBER"
        printcomment        "Number of vbox defined in ASTERISK_VBOX_n_NUMBER"
        printvar "ASTERISK_SIP_${idx}_VBOX_ANSWER_AFTER"
        printcomment        "the voicebox answers after ringing of x sec."
        printvar "ASTERISK_SIP_${idx}_REDIRECT_SCHEME"
        printcomment        "Number of the element of the redirect"
        printcomment        "scheme array defined below"

        echo
        idx=$(expr $idx + 1)
    done


    # -----------------------------------------------------------------------
    printgroup "IAX-Proxy configuration" "(e.g. voipbuster.com)"
    # -----------------------------------------------------------------------

    printvar 'ASTERISK_IAX_QUALIFY'
    printcomment            "'yes' Asterisk send pings to the other side"
    printcomment            "'no' default"

    printvar "ASTERISK_IAX_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_IAX_N}" ]
    do
        printvar "ASTERISK_IAX_${idx}_ACTIVE"
        printvar "ASTERISK_IAX_${idx}_NAME"
        printcomment        "Name of this IAX-Account"
        printvar "ASTERISK_IAX_${idx}_USER"
        printcomment        "User ID of this IAX-Account"
        printvar "ASTERISK_IAX_${idx}_PASSWORD"
        printcomment        "Password of this IAX-Account"
        printvar "ASTERISK_IAX_${idx}_HOST"
        printcomment        "Host of the IAX-Proxy"
        printvar "ASTERISK_IAX_${idx}_CALLERID"
        printcomment        "Used as caller id for outgoing calls"
        printvar "ASTERISK_IAX_${idx}_FALLBACK"
        printcomment        "If the account is down use those"
        printcomment        "(in the given order) instead"
        printvar "ASTERISK_IAX_${idx}_EXEC_ON_RING"
        printcomment        "Command to execute on ring"
        printvar "ASTERISK_IAX_${idx}_VBOX"
        printcomment        "Enable the vbox for this IAX account"
        printvar "ASTERISK_IAX_${idx}_VBOX_NUMBER"
        printcomment        "Number of vbox defined in ASTERISK_VBOX_n_NUMBER"
        printvar "ASTERISK_IAX_${idx}_VBOX_ANSWER_AFTER"
        printcomment        "the voicebox answers after ringing of x sec."
        printvar "ASTERISK_IAX_${idx}_REDIRECT_SCHEME"
        printcomment        "Number of the element of the redirect"
        printcomment        "scheme array defined below"

        echo
        idx=$(expr $idx + 1)
    done

    # -----------------------------------------------------------------------
    printgroup "Local telephone configuration" "(Connected to the HFC-S ISDN-Card)"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_PHONES_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_PHONES_N}" ]
    do
        printvar "ASTERISK_PHONES_${idx}_ACTIVE"
        printvar "ASTERISK_PHONES_${idx}_MSN"
        printcomment        "MSN of the connected telephone"
        printvar "ASTERISK_PHONES_${idx}_TYPE"
        printcomment        "hfcs, sip or disa"
        printvar "ASTERISK_PHONES_${idx}_MAC_ADDR"
        printcomment        "MAC addr for Cisco phones only"
        printvar "ASTERISK_PHONES_${idx}_PIN"
        printcomment        "PIN for VBOX"
        printvar "ASTERISK_PHONES_${idx}_RING_ON_SIP"
        printcomment        "SIP-Accounts (ASTERISK_SIP_n_NAME) on which the"
        printcomment        "phone should ring (seperated by spaces)"
        printvar "ASTERISK_PHONES_${idx}_RING_ON_IAX"
        printcomment        "IAX-Accounts (ASTERISK_IAX_n_NAME) on which the"
        printcomment        "phone should ring (seperated by spaces)"
        printvar "ASTERISK_PHONES_${idx}_RING_ON_CAPI"
        printcomment        "external MSNs on which the phone should ring"
        printcomment        "(seperated by spaces)"
        printvar "ASTERISK_PHONES_${idx}_OUTGOING_NAME"
        printcomment        "name to be displayed at the called person"
        printvar "ASTERISK_PHONES_${idx}_OUTGOING_SIP"
        printcomment        "Account to use for SIP dialouts"
        printvar "ASTERISK_PHONES_${idx}_OUTGOING_IAX"
        printcomment        "Account to use for IAX dialouts"
        printvar "ASTERISK_PHONES_${idx}_OUTGOING_MSN"
        printcomment        "MSN to use for convincial telephone"
        printcomment        "network dialouts"
        printvar "ASTERISK_PHONES_${idx}_OUTGOING_HFCS_GROUP"
        printcomment        "HFCS group using for dialouts"
        printcomment        "(ASTERISK_HFCS_GROUP_n_*)"
        printvar "ASTERISK_PHONES_${idx}_EXEC_ON_RING"
        printcomment        "command to execute on ring"
        printvar "ASTERISK_PHONES_${idx}_NETBIOS_NAME"
        printcomment        "netbios name to signalise incoming calls"
        printvar "ASTERISK_PHONES_${idx}_LCR"
        printcomment        "activate LCR for this MSN"
        printcomment        "(only if ASTERISK_LCR=yes)"
        printvar "ASTERISK_PHONES_${idx}_VBOX"
        printcomment        "VBOX for this phone, yes/no"
        printvar "ASTERISK_PHONES_${idx}_VBOX_MAIL"
        printcomment        "recorded messages will be sent to"
        printcomment        "this mail address"
        printvar "ASTERISK_PHONES_${idx}_VBOX_ANSWER_AFTER"
        printcomment        "the voicebox answers after ringing of x sec."

        echo
        idx=$(expr $idx + 1)
    done

    # -----------------------------------------------------------------------
    printgroup "Extra options for external CAPI MSNs"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_MSN_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_MSN_N}" ]
    do
        printvar "ASTERISK_MSN_${idx}_ACTIVE"
        printvar "ASTERISK_MSN_${idx}_NUMBER"
        printcomment        "If this external MSN is called ..."
        printvar "ASTERISK_MSN_${idx}_EXEC_ON_RING"
        printcomment        "... this command will be executed'"
        printvar "ASTERISK_MSN_${idx}_VBOX"
        printcomment        "Enable the vbox for this MSN account"
        printvar "ASTERISK_MSN_${idx}_VBOX_NUMBER"
        printcomment        "Number of vbox defined in ASTERISK_VBOX_n_NUMBER"
        printvar "ASTERISK_MSN_${idx}_VBOX_ANSWER_AFTER"
        printcomment        "the voicebox answers after ringing of x sec."
        printvar "ASTERISK_MSN_${idx}_REDIRECT_SCHEME"
        printcomment        "Number of the element of the redirect"
        printcomment        "scheme array defined below"

        echo
        idx=$(expr ${idx} + 1)
    done


    # -----------------------------------------------------------------------
    printgroup "Voice boxes for external MSNs or SIP/IAX accounts"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_VBOX_N"

    idx1=1
    while [ "${idx1}" -le "${ASTERISK_VBOX_N}" ]
    do
        printvar "ASTERISK_VBOX_${idx1}_ACTIVE"
        printvar "ASTERISK_VBOX_${idx1}_NUMBER"
        printcomment        "Unique number of the vbox, said when the vbox"
        printcomment        "answers the line"
        printvar "ASTERISK_VBOX_${idx1}_PIN"
        printcomment        "The PIN to enter when listen to new messages"
        printvar "ASTERISK_VBOX_${idx1}_OWNER_NAME"
        printcomment        "The name of the owner of the vbox"
        printvar "ASTERISK_VBOX_${idx1}_MAIL"
        printcomment        "Mailaddress where to send new messages"

        echo
        printvar "ASTERISK_VBOX_${idx1}_NOTIFY_N"

        eval notify_n='${ASTERISK_VBOX_'${idx1}'_NOTIFY_N}'

        idx2=1
        while [ "${idx2}" -le "${notify_n}" ]
        do
            printvar "ASTERISK_VBOX_${idx1}_NOTIFY_${idx2}_ACTIVE"
            printvar "ASTERISK_VBOX_${idx1}_NOTIFY_${idx2}_PHONE"
            printcomment    "If the vbox has a new message, the dial tone"
            printcomment    "of the phone given here will stutter"

            echo
            idx2=$(expr ${idx2} + 1)
        done

        echo
        idx1=$(expr ${idx1} + 1)
    done


    # -----------------------------------------------------------------------
    printgroup "Redirect incoming calls"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_REDIRECT_N"

    idx1=1
    while [ "${idx1}" -le "${ASTERISK_REDIRECT_N}" ]
    do
        printvar "ASTERISK_REDIRECT_${idx1}_ACTIVE"
        printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_N"

        eval scheme_n='${ASTERISK_REDIRECT_'${idx1}'_SCHEME_N}'

        idx2=1
        while [ "${idx2}" -le "${scheme_n}" ]
        do
            printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_EXECUTE_BETWEEN_N"

            eval between_n='${ASTERISK_REDIRECT_'${idx1}'_SCHEME_'${idx2}'_EXECUTE_BETWEEN_N}'

            idx3=1
            while [ "${idx3}" -le "${between_n}" ]
            do
                printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_EXECUTE_BETWEEN_${idx3}_TIME"
                printcomment    "between these times the following redirect"
                printcomment    "scheme will be active (else jump to the next scheme)"

                echo
                idx3=$(expr ${idx3} + 1)
            done


            printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_EXECUTE_AFTER"
            printcomment    "jump into the targets below after x sec."

            echo
            printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_TARGET_N"

            eval target_n='${ASTERISK_REDIRECT_'${idx1}'_SCHEME_'${idx2}'_TARGET_N}'

            idx3=1
            while [ "${idx3}" -le "${target_n}" ]
            do
                printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_TARGET_${idx3}_TYPE"
                printcomment    "type of address (internal, capi,"
                printcomment    "hfcs1 - hfcs4, sip, iax, skinny, unistim)"
                printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_TARGET_${idx3}_ADDR"
                printcomment    "number or address of the phone to which the"
                printcomment    "call should be redirected"
                printvar "ASTERISK_REDIRECT_${idx1}_SCHEME_${idx2}_TARGET_${idx3}_FROM"
                printcomment    "Account or MSN to use for the outgoing"
                printcomment    "call of the redirection"

                echo
                idx3=$(expr ${idx3} + 1)
            done

            echo
            idx2=$(expr $idx2 + 1)
        done

        echo
        idx1=$(expr $idx1 + 1)
    done



    # -----------------------------------------------------------------------
    printgroup "Least Cost Routing for outgoing ISDN calls" "(data used from telefonsparbuch.de)"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_LCR"
    printcomment            "Enable LCR from telefonsparbuch.de"
    printvar "ASTERISK_LCR_CRON"
    printcomment            "Update LCR routing file at this time"


    # -----------------------------------------------------------------------
    printgroup "Interactive voice response menu (IVR)"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_IVR_N"

    idx1=1
    while [ "${idx1}" -le  "${ASTERISK_IVR_N}" ]
    do
        printvar "ASTERISK_IVR_${idx1}_ACTIVE"
        printvar "ASTERISK_IVR_${idx1}_NUMBER"
        printvar "ASTERISK_IVR_${idx1}_INSTRUCTIONS"
        printcomment        "GSM file in sounds directory for plaing"
        printcomment        "'press one for tech, two for ...'"

        echo
        printvar "ASTERISK_IVR_${idx1}_ENTRY_N"

        eval entry_n='${ASTERISK_IVR_'${idx1}'_ENTRY_N}'

        idx2=1
        while [ "${idx2}" -le "${entry_n}" ]
        do
            printvar "ASTERISK_IVR_${idx1}_ENTRY_${idx2}_NUMBER"
            printcomment    "Key the user has to press"
            printvar "ASTERISK_IVR_${idx1}_ENTRY_${idx2}_TYPE"
            printcomment    "'dial' or 'exec'"
            printvar "ASTERISK_IVR_${idx1}_ENTRY_${idx2}_VALUE"
            printcomment    "number (incl dialprefix) or command"

            echo
            idx2=$(expr ${idx2} + 1)
        done

        echo
        idx1=$(expr ${idx1} + 1)
    done




    # -----------------------------------------------------------------------
    printgroup "TAPI configuration"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_START_TAPI"
    printcomment            "Should the TAPI server be startet with asterisk?"
    printvar "ASTERISK_TAPI_PORT"
    printcomment            "port on which TAPI should run"

    echo
    printvar "ASTERISK_TAPI_USER_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_TAPI_USER_N}" ]
    do
        printvar "ASTERISK_TAPI_USER_${idx}_NAME"
        printcomment        "Username"
        printvar "ASTERISK_TAPI_USER_${idx}_PASS"
        printcomment        "Password for the user"
        printvar "ASTERISK_TAPI_USER_${idx}_ACCESS"
        printcomment        "From where the user gets access"

        echo
        idx=$(expr ${idx} + 1)
    done

    # -----------------------------------------------------------------------
    printgroup "Callthrough configuration"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_CALLTHROUGH_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_CALLTHROUGH_N}" ]
    do
        printvar "ASTERISK_CALLTHROUGH_${idx}_ACTIVE"
        printvar "ASTERISK_CALLTHROUGH_${idx}_MSN"
        printcomment        "The MSN Asterisk should listen to for"
        printcomment        "incoming callthroughs"
        printvar "ASTERISK_CALLTHROUGH_${idx}_OUTGOING_SIP"
        printcomment        "SIP account to use for dialouts"
        printvar "ASTERISK_CALLTHROUGH_${idx}_OUTGOING_IAX"
        printcomment        "SIP account to use for dialouts"
        printvar "ASTERISK_CALLTHROUGH_${idx}_OUTGOING_MSN"
        printcomment        "MSN to use for dialouts"
        printvar "ASTERISK_CALLTHROUGH_${idx}_OUTGOING_HFCS_GROUP"
        printcomment        "Portgroup to use for calls over HFCS card"
        printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_SIP"
        printcomment        "Allow outgoing SIP calls"
        printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_IAX"
        printcomment        "Allow outgoing IAX calls"
        printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_CAPI"
        printcomment        "Allow outgoing CAPI calls"

        echo
        printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_N"
        printcomment        "These callerids gets access without"
        printcomment        "entering the PIN"

        eval allow_n='${ASTERISK_CALLTHROUGH_'${idx}'_ALLOW_N}'

        idx2=1
        while [ "${idx2}" -le "${allow_n}" ]
        do
            printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_${idx2}_ACTIVE"
            printcomment    'Use: yes or no'
            printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_${idx2}_CALLERID"
            printcomment    "area code + MSN of allowed callthrough phone"
            printvar "ASTERISK_CALLTHROUGH_${idx}_ALLOW_${idx2}_PIN"
            printcomment    "PIN to enter before access is granted,"
            printcomment    "may be empty"

            echo
            idx2=$(expr ${idx2} + 1)
        done

        printvar "ASTERISK_CALLTHROUGH_${idx}_ANONYMOUS_ACCESS"
        printcomment        "Allow access by callerids which are not listed in"
        printcomment        "ASTERISK_CALLTHROUGH_n_ALLOW_m_CALLERIDS"
        printvar "ASTERISK_CALLTHROUGH_${idx}_ANONYMOUS_PIN"
        printcomment        "PIN for unkown callerids, may NOT be empty"

        echo
        idx=$(expr ${idx} + 1)
    done


    # -----------------------------------------------------------------------
    printgroup "Callback configuration"
    # -----------------------------------------------------------------------

    printvar "ASTERISK_CALLBACK"
    printcomment            "Activate callback?"
    printvar "ASTERISK_CALLBACK_LISTEN_NUMBER"
    printcomment            "msn or caller ID of SIP-/IAX-Account to listen to"
    printvar "ASTERISK_CALLBACK_OUTGOING_TYPE"
    printcomment            "type of callback call (capi, sip, iax)"
    printvar "ASTERISK_CALLBACK_OUTGOING_FROM"
    printcomment            "MSN or name of SIP-/IAX-Account"
    printvar "ASTERISK_CALLBACK_GLOBAL_PIN"
    printcomment            "if set, all caller IDs are allowed to"
    printcomment            "initiate a callback with this PIN"

    echo
    printvar "ASTERISK_CALLBACK_ALLOW_N"

    idx=1
    while [ "${idx}" -le "${ASTERISK_CALLBACK_ALLOW_N}" ]
    do
        printvar "ASTERISK_CALLBACK_ALLOW_${idx}_CALLERID"
        printcomment        "Caller ID which is allowed to initiate a callback"
        printvar "ASTERISK_CALLBACK_ALLOW_${idx}_PIN"
        printcomment        "PIN which have the caller to enter"

        echo
        idx=$(expr ${idx} + 1)
    done

    # -----------------------------------------------------------------------
    printend
    # -----------------------------------------------------------------------

    } > ${internal_conf_file}
    # Set rights
    chmod 0600 ${internal_conf_file}
    chown root ${internal_conf_file}

}
# ---------------------------------------------------------------------------
# Create the check.d file
# ---------------------------------------------------------------------------
make_check_file()
{
printgpl --check ${package_name} "2014-11-29" "hb" >/etc/check.d/${package_name}
cat >>/etc/check.d/${package_name} <<EOF
#Variable                                           OPT_VARIABLE                            VARIABLE_N                                      VALUE

START_ASTERISK                                      -                                       -                                               YESNO

ASTERISK_CONFIG_USE                                 START_ASTERISK                          -                                               YESNO
ASTERISK_LOAD_CAPI                                  START_ASTERISK                          -                                               YESNO
ASTERISK_LOAD_DAHDI                                 START_ASTERISK                          -                                               YESNO
ASTERISK_LOG_INTO_FILE                              START_ASTERISK                          -                                               YESNO

ASTERISK_LANGUAGE                                   ASTERISK_CONFIG_USE                     -                                               ASTERISK_LANGUAGE
ASTERISK_CODECS                                     ASTERISK_CONFIG_USE                     -                                               ASTERISK_STRINGS
ASTERISK_ADVANCED_ERROR_MSG                         ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_RECORD_CONVERSATION                        ASTERISK_CONFIG_USE                     -                                               YESNO


ASTERISK_HFCS_GROUP_N                               ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_HFCS_GROUP_%_ACTIVE                        ASTERISK_CONFIG_USE                     ASTERISK_HFCS_GROUP_N                           YESNO
#ASTERISK_HFCS_GROUP_%_TYPE                          ASTERISK_HFCS_GROUP_%_ACTIVE            ASTERISK_HFCS_GROUP_N                           ASTERISK_HFCS_TYPE
ASTERISK_HFCS_GROUP_%_PROVIDE_S0_BUS                ASTERISK_HFCS_GROUP_%_ACTIVE            ASTERISK_HFCS_GROUP_N                           YESNO
ASTERISK_HFCS_GROUP_%_PTP                           ASTERISK_HFCS_GROUP_%_ACTIVE            ASTERISK_HFCS_GROUP_N                           YESNO
ASTERISK_HFCS_GROUP_%_PORTS                         ASTERISK_HFCS_GROUP_%_ACTIVE            ASTERISK_HFCS_GROUP_N                           NUMERIC

ASTERISK_FX_GROUP_N                                 ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_FX_GROUP_%_ACTIVE                          ASTERISK_CONFIG_USE                     ASTERISK_FX_GROUP_N                             YESNO
ASTERISK_FX_GROUP_%_TYPE                            ASTERISK_FX_GROUP_%_ACTIVE              ASTERISK_FX_GROUP_N                             ASTERISK_FX_TYPE
ASTERISK_FX_GROUP_%_PORTS                           ASTERISK_FX_GROUP_%_ACTIVE              ASTERISK_FX_GROUP_N                             NUMERIC

ASTERISK_WEBINTERFACE_START                         ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_WEBINTERFACE_FORCE_SSL                     ASTERISK_WEBINTERFACE_START             -                                               YESNO
ASTERISK_WEBINTERFACE_CERTIFICATE                   ASTERISK_WEBINTERFACE_FORCE_SSL         -                                               ASTERISK_WEBINTERFACE_CERTIFICATE_CUI
ASTERISK_WEBINTERFACE_N                             ASTERISK_WEBINTERFACE_START             -                                               NUMERIC
ASTERISK_WEBINTERFACE_%_USER                        ASTERISK_WEBINTERFACE_START             ASTERISK_WEBINTERFACE_N                         NONE
ASTERISK_WEBINTERFACE_%_PASSWD                      ASTERISK_WEBINTERFACE_START             ASTERISK_WEBINTERFACE_N                         NONE

ASTERISK_SIP_PORT                                   ASTERISK_CONFIG_USE                     -                                               PORT
ASTERISK_RTP_PORTS                                  ASTERISK_CONFIG_USE                     -                                               RE:((RE:PORT)-(RE:PORT))

ASTERISK_LOCALNETS_N                                ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_LOCALNETS_%_NAME                           ASTERISK_CONFIG_USE                     ASTERISK_LOCALNETS_N                            NONE
ASTERISK_LOCALNETS_%_ACTIVE                         ASTERISK_CONFIG_USE                     ASTERISK_LOCALNETS_N                            YESNO
ASTERISK_LOCALNETS_%_IP                             ASTERISK_LOCALNETS_%_ACTIVE             ASTERISK_LOCALNETS_N                            NETWORK
ASTERISK_LISTEN_ADDR                                ASTERISK_CONFIG_USE                     -                                               IPADDR
ASTERISK_EXTERNIP                                   ASTERISK_CONFIG_USE                     -                                               ASTERISK_EIP_OR_EFQDN

ASTERISK_DIALPREFIX_SIP                             ASTERISK_CONFIG_USE                     -                                               ASTERISK_EPHONENUMBER
ASTERISK_DIALPREFIX_IAX                             ASTERISK_CONFIG_USE                     -                                               ASTERISK_EPHONENUMBER
ASTERISK_DIALPREFIX_CAPI                            ASTERISK_CONFIG_USE                     -                                               ASTERISK_EPHONENUMBER
ASTERISK_DIALPREFIX_INTERNAL                        ASTERISK_CONFIG_USE                     -                                               ASTERISK_EPHONENUMBER
ASTERISK_DIALPREFIX_VBOX                            ASTERISK_CONFIG_USE                     -                                               ASTERISK_EPHONENUMBER
ASTERISK_DIALPREFIX_DISA                            ASTERISK_CONFIG_USE                     -                                               ASTERISK_EPHONENUMBER

ASTERISK_DIALPREFIX_SHOW_CAPI                       ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_DIALPREFIX_SHOW_SIP                        ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_DIALPREFIX_SHOW_IAX                        ASTERISK_CONFIG_USE                     -                                               YESNO

ASTERISK_AREA_CODE                                  ASTERISK_CONFIG_USE                     -                                               NONE

ASTERISK_VMAIL_FROM_ADDR                            ASTERISK_CONFIG_USE                     -                                               EMAILADDR
ASTERISK_VMAIL_FROM_NAME                            ASTERISK_CONFIG_USE                     -                                               NONE
ASTERISK_VBOX_MAX_MSG_LENGTH                        ASTERISK_CONFIG_USE                     -                                               ENUMERIC
ASTERISK_VBOX_PLAY_INSTRUCTIONS                     ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_VBOX_AUTODETECT_CID                        ASTERISK_CONFIG_USE                     -                                               YESNO

ASTERISK_RESOLVE_NUMBERS                            ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_RESOLVE_NUMBERS_REMOTE                     ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_RESOLVE_NUMBERS_SOURCE                     ASTERISK_CONFIG_USE                     -                                               RE:(file|db)
ASTERISK_RESOLVE_NUMBERS_PATH                       ASTERISK_CONFIG_USE                     -                                               ABS_PATH
ASTERISK_RESOLVE_NUMBERS_DB_HOST                    ASTERISK_CONFIG_USE                     -                                               NONE
ASTERISK_RESOLVE_NUMBERS_DB_USER                    ASTERISK_CONFIG_USE                     -                                               NONE
ASTERISK_RESOLVE_NUMBERS_DB_PASS                    ASTERISK_CONFIG_USE                     -                                               NONE
ASTERISK_RESOLVE_NUMBERS_DB_NAME                    ASTERISK_CONFIG_USE                     -                                               NONE
ASTERISK_RESOLVE_NUMBERS_DB_TABLE                   ASTERISK_CONFIG_USE                     -                                               NONE

ASTERISK_SIP_QUALIFY                                ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_SIP_N                                      ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_SIP_%_ACTIVE                               ASTERISK_CONFIG_USE                     ASTERISK_SIP_N                                  YESNO
ASTERISK_SIP_%_NAME                                 ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  ASTERISK_STRING
ASTERISK_SIP_%_USER                                 ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  NONE
ASTERISK_SIP_%_PASSWORD                             ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  NONE
ASTERISK_SIP_%_HOST                                 ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  FQDN
ASTERISK_SIP_%_CALLERID                             ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  NUMERIC
ASTERISK_SIP_%_FALLBACK                             ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  ASTERISK_EFALLBACK
ASTERISK_SIP_%_EXEC_ON_RING                         ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  NONE
ASTERISK_SIP_%_VBOX                                 ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  YESNO
ASTERISK_SIP_%_VBOX_NUMBER                          ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  ENUMERIC
ASTERISK_SIP_%_VBOX_ANSWER_AFTER                    ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  ENUMERIC
ASTERISK_SIP_%_REDIRECT_SCHEME                      ASTERISK_SIP_%_ACTIVE                   ASTERISK_SIP_N                                  ENUMERIC

ASTERISK_IAX_QUALIFY                                ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_IAX_N                                      ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_IAX_%_ACTIVE                               ASTERISK_CONFIG_USE                     ASTERISK_IAX_N                                  YESNO
ASTERISK_IAX_%_NAME                                 ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  ASTERISK_STRING
ASTERISK_IAX_%_USER                                 ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  NONE
ASTERISK_IAX_%_PASSWORD                             ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  NONE
ASTERISK_IAX_%_HOST                                 ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  FQDN
ASTERISK_IAX_%_CALLERID                             ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  NUMERIC
ASTERISK_IAX_%_FALLBACK                             ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  ASTERISK_EFALLBACK
ASTERISK_IAX_%_EXEC_ON_RING                         ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  NONE
ASTERISK_IAX_%_VBOX                                 ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  YESNO
ASTERISK_IAX_%_VBOX_NUMBER                          ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  ENUMERIC
ASTERISK_IAX_%_VBOX_ANSWER_AFTER                    ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  ENUMERIC
ASTERISK_IAX_%_REDIRECT_SCHEME                      ASTERISK_IAX_%_ACTIVE                   ASTERISK_IAX_N                                  ENUMERIC

ASTERISK_PHONES_N                                   ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_PHONES_%_ACTIVE                            ASTERISK_CONFIG_USE                     ASTERISK_PHONES_N                               YESNO
ASTERISK_PHONES_%_TYPE                              ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_TYPE
ASTERISK_PHONES_%_MAC_ADDR                          ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               NONE
ASTERISK_PHONES_%_MSN                               ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_PHONENUMBER
ASTERISK_PHONES_%_PIN                               ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ENUMERIC
ASTERISK_PHONES_%_RING_ON_SIP                       ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_ESTRINGS
ASTERISK_PHONES_%_RING_ON_IAX                       ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_ESTRINGS
ASTERISK_PHONES_%_RING_ON_CAPI                      ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_EPHONENUMBERS
ASTERISK_PHONES_%_OUTGOING_NAME                     ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               NONE
ASTERISK_PHONES_%_OUTGOING_SIP                      ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_ESTRING
ASTERISK_PHONES_%_OUTGOING_IAX                      ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_ESTRING
ASTERISK_PHONES_%_OUTGOING_MSN                      ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_EPHONENUMBER
ASTERISK_PHONES_%_OUTGOING_HFCS_GROUP               ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ENUMERIC
ASTERISK_PHONES_%_EXEC_ON_RING                      ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               NONE
ASTERISK_PHONES_%_NETBIOS_NAME                      ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               NONE
ASTERISK_PHONES_%_LCR                               ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               YESNO
ASTERISK_PHONES_%_VBOX                              ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               YESNO
ASTERISK_PHONES_%_VBOX_MAIL                         ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ASTERISK_MULTIPLE_MAILADDR
ASTERISK_PHONES_%_VBOX_ANSWER_AFTER                 ASTERISK_PHONES_%_ACTIVE                ASTERISK_PHONES_N                               ENUMERIC

ASTERISK_MSN_N                                      ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_MSN_%_ACTIVE                               ASTERISK_CONFIG_USE                     ASTERISK_MSN_N                                  YESNO
ASTERISK_MSN_%_NUMBER                               ASTERISK_MSN_%_ACTIVE                   ASTERISK_MSN_N                                  ASTERISK_PHONENUMBER
ASTERISK_MSN_%_EXEC_ON_RING                         ASTERISK_MSN_%_ACTIVE                   ASTERISK_MSN_N                                  NONE
ASTERISK_MSN_%_VBOX                                 ASTERISK_MSN_%_ACTIVE                   ASTERISK_MSN_N                                  YESNO
ASTERISK_MSN_%_VBOX_NUMBER                          ASTERISK_MSN_%_ACTIVE                   ASTERISK_MSN_N                                  ENUMERIC
ASTERISK_MSN_%_VBOX_ANSWER_AFTER                    ASTERISK_MSN_%_ACTIVE                   ASTERISK_MSN_N                                  ENUMERIC
ASTERISK_MSN_%_REDIRECT_SCHEME                      ASTERISK_MSN_%_ACTIVE                   ASTERISK_MSN_N                                  ENUMERIC

ASTERISK_VBOX_N                                     ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_VBOX_%_ACTIVE                              ASTERISK_CONFIG_USE                     ASTERISK_VBOX_N                                 YESNO
ASTERISK_VBOX_%_NUMBER                              ASTERISK_VBOX_%_ACTIVE                  ASTERISK_VBOX_N                                 NUMERIC
ASTERISK_VBOX_%_PIN                                 ASTERISK_VBOX_%_ACTIVE                  ASTERISK_VBOX_N                                 ENUMERIC
ASTERISK_VBOX_%_OWNER_NAME                          ASTERISK_VBOX_%_ACTIVE                  ASTERISK_VBOX_N                                 NONE
ASTERISK_VBOX_%_MAIL                                ASTERISK_VBOX_%_ACTIVE                  ASTERISK_VBOX_N                                 ASTERISK_MULTIPLE_MAILADDR
ASTERISK_VBOX_%_NOTIFY_N                            ASTERISK_VBOX_%_ACTIVE                  ASTERISK_VBOX_N                                 NUMERIC
ASTERISK_VBOX_%_NOTIFY_%_ACTIVE                     ASTERISK_VBOX_%_ACTIVE                  ASTERISK_VBOX_%_NOTIFY_N                        YESNO
ASTERISK_VBOX_%_NOTIFY_%_PHONE                      ASTERISK_VBOX_%_NOTIFY_%_ACTIVE         ASTERISK_VBOX_%_NOTIFY_N                        NUMERIC

ASTERISK_REDIRECT_N                                 ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_REDIRECT_%_ACTIVE                          ASTERISK_CONFIG_USE                     ASTERISK_REDIRECT_N                             YESNO
ASTERISK_REDIRECT_%_SCHEME_N                        ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_N                             NUMERIC
ASTERISK_REDIRECT_%_SCHEME_%_EXECUTE_AFTER          ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_N                    NUMERIC
ASTERISK_REDIRECT_%_SCHEME_%_EXECUTE_BETWEEN_N      ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_N                    NUMERIC
ASTERISK_REDIRECT_%_SCHEME_%_EXECUTE_BETWEEN_%_TIME ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_%_EXECUTE_BETWEEN_N  NONE
ASTERISK_REDIRECT_%_SCHEME_%_TARGET_N               ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_N                    NUMERIC
ASTERISK_REDIRECT_%_SCHEME_%_TARGET_%_TYPE          ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_%_TARGET_N           ASTERISK_TYPE
ASTERISK_REDIRECT_%_SCHEME_%_TARGET_%_ADDR          ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_%_TARGET_N           ASTERISK_SIP_OR_PHONE
ASTERISK_REDIRECT_%_SCHEME_%_TARGET_%_FROM          ASTERISK_REDIRECT_%_ACTIVE              ASTERISK_REDIRECT_%_SCHEME_%_TARGET_N           NONE

ASTERISK_LCR                                        ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_LCR_CRON                                   ASTERISK_LCR                            -                                               CRONTAB

ASTERISK_IVR_N                                      ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_IVR_%_ACTIVE                               ASTERISK_CONFIG_USE                     ASTERISK_IVR_N                                  YESNO
ASTERISK_IVR_%_NUMBER                               ASTERISK_IVR_%_ACTIVE                   ASTERISK_IVR_N                                  ASTERISK_PHONENUMBER
ASTERISK_IVR_%_INSTRUCTIONS                         ASTERISK_IVR_%_ACTIVE                   ASTERISK_IVR_N                                  NONE
ASTERISK_IVR_%_ENTRY_N                              ASTERISK_IVR_%_ACTIVE                   ASTERISK_IVR_N                                  NUMERIC
ASTERISK_IVR_%_ENTRY_%_NUMBER                       ASTERISK_IVR_%_ACTIVE                   ASTERISK_IVR_%_ENTRY_N                          ASTERISK_PHONENUMBER
ASTERISK_IVR_%_ENTRY_%_TYPE                         ASTERISK_IVR_%_ACTIVE                   ASTERISK_IVR_%_ENTRY_N                          NONE
ASTERISK_IVR_%_ENTRY_%_VALUE                        ASTERISK_IVR_%_ACTIVE                   ASTERISK_IVR_%_ENTRY_N                          NONE

ASTERISK_START_TAPI                                 ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_TAPI_PORT                                  ASTERISK_CONFIG_USE                     -                                               PORT
ASTERISK_TAPI_USER_N                                ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_TAPI_USER_%_NAME                           ASTERISK_CONFIG_USE                     ASTERISK_TAPI_USER_N                            ASTERISK_STRING
ASTERISK_TAPI_USER_%_PASS                           ASTERISK_CONFIG_USE                     ASTERISK_TAPI_USER_N                            NONE
ASTERISK_TAPI_USER_%_ACCESS                         ASTERISK_CONFIG_USE                     ASTERISK_TAPI_USER_N                            NETWORK

ASTERISK_CALLTHROUGH_N                              ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_CALLTHROUGH_%_ACTIVE                       ASTERISK_CONFIG_USE                     ASTERISK_CALLTHROUGH_N                          YESNO
ASTERISK_CALLTHROUGH_%_MSN                          ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          ASTERISK_PHONENUMBER
ASTERISK_CALLTHROUGH_%_OUTGOING_SIP                 ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          ASTERISK_STRING
ASTERISK_CALLTHROUGH_%_OUTGOING_IAX                 ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          ASTERISK_STRING
ASTERISK_CALLTHROUGH_%_OUTGOING_MSN                 ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          ASTERISK_PHONENUMBER
ASTERISK_CALLTHROUGH_%_OUTGOING_HFCS_GROUP          ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          ENUMERIC
ASTERISK_CALLTHROUGH_%_ALLOW_SIP                    ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          YESNO
ASTERISK_CALLTHROUGH_%_ALLOW_IAX                    ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          YESNO
ASTERISK_CALLTHROUGH_%_ALLOW_CAPI                   ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          YESNO
ASTERISK_CALLTHROUGH_%_ALLOW_N                      ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          NUMERIC
ASTERISK_CALLTHROUGH_%_ALLOW_%_ACTIVE               ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_%_ALLOW_N                  YESNO
ASTERISK_CALLTHROUGH_%_ALLOW_%_CALLERID             ASTERISK_CALLTHROUGH_%_ALLOW_%_ACTIVE   ASTERISK_CALLTHROUGH_%_ALLOW_N                  ASTERISK_PHONENUMBER
ASTERISK_CALLTHROUGH_%_ALLOW_%_PIN                  ASTERISK_CALLTHROUGH_%_ALLOW_%_ACTIVE   ASTERISK_CALLTHROUGH_%_ALLOW_N                  ENUMERIC
ASTERISK_CALLTHROUGH_%_ANONYMOUS_ACCESS             ASTERISK_CALLTHROUGH_%_ACTIVE           ASTERISK_CALLTHROUGH_N                          YESNO
ASTERISK_CALLTHROUGH_%_ANONYMOUS_PIN                ASTERISK_CALLTHROUGH_%_ANONYMOUS_ACCESS ASTERISK_CALLTHROUGH_N                          NUMERIC

ASTERISK_CALLBACK                                   ASTERISK_CONFIG_USE                     -                                               YESNO
ASTERISK_CALLBACK_LISTEN_NUMBER                     ASTERISK_CONFIG_USE                     -                                               ASTERISK_PHONENUMBER
ASTERISK_CALLBACK_OUTGOING_TYPE                     ASTERISK_CONFIG_USE                     -                                               ASTERISK_TYPE
ASTERISK_CALLBACK_OUTGOING_FROM                     ASTERISK_CONFIG_USE                     -                                               NONE
ASTERISK_CALLBACK_GLOBAL_PIN                        ASTERISK_CONFIG_USE                     -                                               ENUMERIC
ASTERISK_CALLBACK_ALLOW_N                           ASTERISK_CONFIG_USE                     -                                               NUMERIC
ASTERISK_CALLBACK_ALLOW_%_CALLERID                  ASTERISK_CONFIG_USE                     ASTERISK_CALLBACK_ALLOW_N                       ASTERISK_PHONENUMBER
ASTERISK_CALLBACK_ALLOW_%_PIN                       ASTERISK_CONFIG_USE                     ASTERISK_CALLBACK_ALLOW_N                       ENUMERIC
EOF

    # Set rights for check.d file
    chmod 0600 /etc/check.d/${package_name}
    chown root /etc/check.d/${package_name}


printgpl --check_exp ${package_name} "2014-11-29" "hb"  >/etc/check.d/${package_name}.exp
cat >>/etc/check.d/${package_name}.exp <<EOF
ASTERISK_LANGUAGE      = 'de|en|fr'
                       : 'Must be en for English or de for German or fr for Frensh'

ASTERISK_STRINGS       = '[-0-9A-Za-z. ]+'
                       : 'May contain characters, digits, points, dashes and spaces'

ASTERISK_ESTRINGS      = '(RE:ASTERISK_STRINGS)|()'
                       : 'May contain characters, digits and spaces or nothing'

ASTERISK_STRING        = '[-0-9A-Za-z.]+'
                       : 'May contain characters and digits'

ASTERISK_ESTRING       = '(RE:ASTERISK_STRING)|()'
                       : 'May contain characters and digits or nothing'

ASTERISK_PHONENUMBER   = '[0-9*#]+'
                       : 'May contain digits, "*" and "#"'

ASTERISK_EPHONENUMBER  = '(RE:ASTERISK_PHONENUMBER)|()'
                       : 'May contain digits, "*" and "#" or nothing'

ASTERISK_PHONENUMBERS  = '[0-9*# ]+'
                       : 'May contain digits, "*",  "#" and spaces'

ASTERISK_EPHONENUMBERS = '(RE:ASTERISK_PHONENUMBERS)|()'
                       : 'May contain digits, "*",  "#" and spaces or nothing'

ASTERISK_EIP_OR_EFQDN  = '(RE:IPADDR)|(RE:FQDN)|()'
                       : 'IP address or hostname + domain name (FQDN)'

ASTERISK_HFCS_GROUP    = 'hfcs[1-9]*'
                       : 'Variable must contain hfcs1, hfcs2, ...'

ASTERISK_TYPE          = 'sip|(RE:ASTERISK_HFCS_GROUP)|disa|skinny|sccp|unistim|iax|vbox|internal|capi'
                       : 'TYPE must be sip, capi, hfcs, skinny, sccp, unistim or disa'

ASTERISK_FX_TYPE       = 'fxo|fxs|none'
                       : 'TYPE must be fxs, fxo or none'

ASTERISK_HFCS_TYPE     = 'zaphfc|multi'
                       : 'TYPE must be zaphfc or multi'

ASTERISK_SIP_OR_PHONE  = '(RE:ASTERISK_PHONENUMBER)|(RE:EMAILADDR)|()'
                       : 'May contain a MSN or a SIP address (user@domain.tld)'

ASTERISK_EFALLBACK     = '(capi:(RE:ASTERISK_PHONENUMBER)|(RE:ASTERISK_HFCS_GROUP):(RE:ASTERISK_PHONENUMBER)|(sip|iax):(RE:ASTERISK_STRING)|( ))*'
                       : 'Must be given in the format sip:[SIP account name]
                         capi:[outgoing MSN] hfcs[ASTERISK_HFCS_GROUP_n_*]:[outgoing MSN]
                         e.g. "sip:sipgate capi:123456 sip:gmx" hfcs1:123456'

ASTERISK_MULTIPLE_MAILADDR = '((RE:MAILADDR)[,]{0,1})*(RE:EMAILADDR)'
                       : 'Must be one email address or multiple addresses seperated by commas'

ASTERISK_WEBINTERFACE_CERTIFICATE_CUI = '(RE:NOTEMPTY)'
                                     : 'SSL Server Certificat Name'
EOF

    # Set rights for check.exp file
    chmod 0600 /etc/check.d/${package_name}.exp
    chown root /etc/check.d/${package_name}.exp


printgpl --check_ext ${package_name} "2015-04-06" "hb"  >/etc/check.d/${package_name}.ext
cat >>/etc/check.d/${package_name}.ext <<EOF
if ( asterisk_webinterface_force_ssl == "no" )
then
    warning " For better security use ASTERISK_WEBINTERFACE_FORCE_SSL = 'yes'"
fi
EOF

    # Set rights for check.ext file
    chmod 0600 /etc/check.d/${package_name}.ext
    chown root /etc/check.d/${package_name}.ext

}
# ---------------------------------------------------------------------------
# main
# ---------------------------------------------------------------------------
# write default config file
make_config_file /etc/default.d/${package_name}

# update from old version
rename_old_variables

# write new config file
make_config_file /etc/config.d/${package_name}

# write check.d file
make_check_file

exit 0
# ---------------------------------------------------------------------------
# end
#----------------------------------------------------------------------------
