<?php
/**
 *---------------------------------------------------------------------------
 * /var/lib/asterisk/config/validate.php - Contains funtions to validate values to correct content
 *
 * Creation:     28.10.2005  fw
 * Last Update:  $Id: validate.php 7799 2014-10-22 18:47:43Z holbru $
 *
 * Copyright (c) 2005 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------
 */

function validateVbox($type, $verbose = false) {
    global $VARS;

    ### Error messages will be printed in writeContexts.php (approx. line 510)

    if ($VARS["ASTERISK_".$type."_N"] > 0) {
        foreach ($VARS["ASTERISK_".$type] as $key => $vbox) {

            $isValid = true;

            if ($vbox["VBOX"] == "yes") {

                if ($vbox["VBOX_NUMBER"] == "") {
                    if ($verbose)
                        err("ASTERISK_".$type."_".$key."_VBOX_NUMBER is empty! Skipping...", __LINE__);
                    $isValid = false;
                } else {
                    if (!isValidVbox($vbox["VBOX_NUMBER"])) {
                        err("The vbox number \"".$vbox["VBOX_NUMBER"]."\" given in ASTERISK_".$type."_".$key."_VBOX_NUMBER doesn't exist! Please define it in ASTERISK_VBOX_*. Skipping...", __LINE__);
                        $isValid = false;
                    }
                }

                if ($vbox["VBOX_ANSWER_AFTER"] == "") {
                    if ($verbose)
                        err("ASTERISK_".$type."_".$key."_VBOX_ANSWER_AFTER is empty! Skipping...", __LINE__);
                    $isValid = false;
                }

                if (!$isValid)
                    continue;
            }
        }
    }

    if (isset($isValid)) {
        return true;
    } else {
        return false;
    }
}

function isValidMSN() {
}

function isValidVbox($number) {
    global $VARS;

    $keys = multi_array_search($number, $VARS["ASTERISK_VBOX"], "NUMBER");

    if ($keys === false) {
        return false;
    } else {
        return true;
    }
}

function isValidSIPAcc() {
}

function isValidIAXAcc() {
}
function isValidInternalMSN() {
}

function isValidType() {
}

?>
