<?php
/**
 *---------------------------------------------------------------------------
 * A Script to write an Eisfair-Asterisk configuration file
 *
 * Creation:     28.10.2005  fw
 * Last Update:  $Id: wcIax.php 8428 2015-03-08 22:18:56Z holbru $
 *
 * Copyright (c) 2005 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------
 */

if (empty($wcContent)) {
    $wcContent = '';
}

$wcContent.= '[general]'."\n";
$wcContent.= 'port=5036'."\n";
$wcContent.= ';bandwidth=high'."\n";
$wcContent.= writeCodecs();
$wcContent.= ';jitterbuffer=no'."\n";
$wcContent.= 'tos=ef'."\n\n";

if (isset ($VARS['ASTERISK_IAX'])) {

    $wcContent.= writeIaxSipRegistries('iax');

    $wcContent.= "\n".'; Write IAX-Proxy accounts'."\n";

    foreach ($VARS['ASTERISK_IAX'] as $iax) {
        $wcContent.= '['.$iax['NAME']."]\n";
        $wcContent.= 'type=peer'."\n";
        $wcContent.= 'context=incoming'."\n";
        $wcContent.= 'username='.$iax['USER']."\n";
        $wcContent.= 'secret='.$iax['PASSWORD']."\n";
        $wcContent.= 'host='.$iax['HOST']."\n";
        $wcContent.= 'qualify='.$VARS['ASTERISK_IAX_QUALIFY']."\n\n";
    }
}
?>
