<?php
/**
 *---------------------------------------------------------------------------
 * A Script to write an Eisfair-Asterisk configuration file
 *
 * Creation:     2005-10-28 fw
 * Last Update:  $Id: wcManager.php 7799 2014-10-22 18:47:43Z holbru $
 *
 * Copyright (c) 2005 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------
 */

if (empty($wcContent)) {
    $wcContent = '';
}

if ($VARS['ASTERISK_START_TAPI'] == 'yes') {
    $wcContent.= '[general]'."\n";
    $wcContent.= 'enabled=yes'."\n";
    $wcContent.= 'port=5038'."\n";
    $wcContent.= 'bindaddr=0.0.0.0'."\n";

    if (isset ($VARS['ASTERISK_TAPI_USER'])) {
        foreach ($VARS['ASTERISK_TAPI_USER'] as $user) {
            $wcContent.= "\n".'['.$user['NAME'].']'."\n";
            $wcContent.= 'secret='.$user['PASS']."\n";
            $wcContent.= 'deny=0.0.0.0/0.0.0.0'."\n";
            $wcContent.= "permit=".$user["ACCESS"]."\n";
            $wcContent.= 'read=system,call,log,verbose,command,agent,user'."\n";
            $wcContent.= 'write=system,call,log,verbose,command,';
            $wcContent.= 'agent,user'."\n\n";
        }

        $wcContent.= '[web]'."\n";
        $wcContent.= 'secret='."\n";
        $wcContent.= 'deny=0.0.0.0/0.0.0.0'."\n";
        $wcContent.= 'permit=127.0.0.1/8'."\n";
        $wcContent.= 'read=system,call,log,verbose,command,agent,user'."\n";
        $wcContent.= 'write=system,call,log,verbose,command,agent,user'."\n";

    } else {
        $my_err  = "No TAPI users were set. You'll be unable to";
        $my_err .= ' log into the TAPI interface';
        err($my_err, __LINE__);
    }
} else {
    $wcContent.= '[general]'."\n";
    $wcContent.= 'enabled=no'."\n";
    $wcContent.= 'port=5038'."\n";
    $wcContent.= 'bindaddr=0.0.0.0'."\n\n";
}
?>
