<?php
/**
 *---------------------------------------------------------------------------
 * A Script to write an Eisfair-Asterisk configuration file
 *
 * Creation:     2005-10-28 fw
 * Last Update:  $Id: wcSkinny.php 8115 2014-11-20 22:40:48Z holbru $
 *
 * Copyright (c) 2005 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------
 */

if (empty($wcContent)) {
    $wcContent = '';
}

$wcContent.= '[general]'."\n";
//$wcContent.= 'port=2000'."\n";
$wcContent.= 'bindaddr='.$VARS['ASTERISK_LISTEN_ADDR']."\n";
$wcContent.= 'dateFormat=D-M-Y'."\n";
$wcContent.= 'keepAlive=120'."\n";
//$wcContent.= 'language='.$VARS['ASTERISK_LANGUAGE']."\n\n";

if (isset ($VARS['ASTERISK_PHONES']))
    foreach ($VARS['ASTERISK_PHONES'] as $phone) {
        if ($phone['TYPE'] != 'skinny') {
            continue;
        }

        $wcContent.= '[cisco'.$phone['MSN']."]\n";
        $wcContent.= 'device=SEP'.$phone['MAC_ADDR']."\n";
        $wcContent.= "callerid=\"".$phone['OUTGOING_NAME']."\" <".$phone['MSN'].">\n";
        $wcContent.= 'callwaiting=1'."\n";
        $wcContent.= 'transfer=1'."\n";
        $wcContent.= 'threewaycalling=1'."\n";
        $wcContent.= 'line => '.$phone['MSN']."\n\n";
    }
?>
