<?php
/**
 *---------------------------------------------------------------------------
 * /var/lib/asterisk/webinterface/htdocs/functionsOutput.inc.php
 *
 * Creation:     2005-04-16  fw
 * Last Update:  $Id: functionsOutput.inc.php 8456 2015-03-14 23:22:52Z holbru $
 *
 * Copyright (c) 2005 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------
 */

function msg($messages)
{
    global $_SERVER, $_colors;

    if(empty($messages)) return;

    $messages = explode("\n", $messages);

    echo "<div class=\"error_message\">\n<ul>\n";
    foreach($messages as $message) {
        if(empty($message)) continue;
//        #$message = explode(";", $message);
        if (empty($all)) {
            $all = '';
        }
//        #print_r($messages);

        preg_match("#(.*);(.*)#", $message, $matches);

//        #if($global_mode == "console") $matches[1] = strip_tags($matches[1]);

        /**
         * charset UTF-8
         */
        $matches[1] = str_replace('<br>', "\n", $matches[1]);
        $matches[1] = str_replace('<br />', "\n", $matches[1]);
        $matches[1] = str_replace('&auml;', 'ä', $matches[1]);
        $matches[1] = str_replace('&Auml;', 'Ä', $matches[1]);
        $matches[1] = str_replace('&ouml;', 'ö', $matches[1]);
        $matches[1] = str_replace('&Ouml;', 'Ö', $matches[1]);
        $matches[1] = str_replace('&uuml;', 'ü', $matches[1]);
        $matches[1] = str_replace('&Uuml;', 'Ü', $matches[1]);
        $matches[1] = str_replace('&szlig;', 'ß', $matches[1]);
        $matches[1] = str_replace('<em>', '[em]', $matches[1]);
        $matches[1] = str_replace('</em>', '[/em]', $matches[1]);
        $matches[1] = str_replace('<pre>', '[pre]', $matches[1]);
        $matches[1] = str_replace('</pre>', '[/pre]', $matches[1]);
        $matches[1] = str_replace('<strong>', '[strong]', $matches[1]);
        $matches[1] = str_replace('</strong>', '[/strong]', $matches[1]);
        $matches[1] = str_replace('</a>', '[/a]', $matches[1]);
        $matches[1] = preg_replace("/<a href=\"([^\"]*)\">/", "[a href=#\\1#]", $matches[1]);
        $matches[1] = htmlentities($matches[1]);
        $matches[1] = preg_replace("/\[a href=#([^#]*)#\]/", "<a href=\"\\1\">", $matches[1]);
        $matches[1] = str_replace('[/a]', '</a>', $matches[1]);
        $matches[1] = str_replace('[em]', '<em>', $matches[1]);
        $matches[1] = str_replace('[/em]', '</em>', $matches[1]);
        $matches[1] = str_replace('[pre]', '<pre>', $matches[1]);
        $matches[1] = str_replace('[/pre]', '</pre>', $matches[1]);
        $matches[1] = str_replace('[strong]', '<strong>', $matches[1]);
        $matches[1] = str_replace('[/strong]', '</strong>', $matches[1]);
        $matches[1] = nl2br($matches[1]);


        if     ($matches[2] == "info"   ) echo "<li><strong style=\"color: green\">INFO:</strong> ".$matches[1]."</li>\n";
        elseif ($matches[2] == "info"   ) echo $_colors["BOLD"].$_colors["GREEN"].$_colors["BOLD"]."INFO: ".strip_tags($matches[1]).$_colors["NORMAL"]."\n";
        elseif ($matches[2] == "info"   ) echo "#<comment> INFO: ".strip_tags($matches[1], "<comment>")."\n";
        elseif ($matches[2] == "warning") echo "<li><strong style=\"color: orange\">WARNUNG:</strong> ".$matches[1]."</li>\n";
        elseif ($matches[2] == "warning") echo $_colors["BOLD"]."WARNING: ".strip_tags($matches[1]).$_colors["NORMAL"]."\n";
        elseif ($matches[2] == "warning") echo "#<comment> WARNING: ".strip_tags($matches[1], "<comment>")."\n";
        elseif ($matches[2] == "error"  ) echo "<li><strong style=\"color: red\">ERROR:</strong> ".$matches[1]."</li>\n";
        elseif ($matches[2] == "error"  ) echo $_colors["BOLD"].$_colors["LIGHT_RED"].$_colors["BOLD"]."ERROR: ".strip_tags($matches[1]).$_colors["NORMAL"]."\n";
        elseif ($matches[2] == "error"  ) echo "#<comment> ERROR: ".strip_tags($matches[1], "<comment>")."\n";
        else echo "Fehler in der Funktion msg(): ".$matches[1];

        if($matches[2] == "error") $all.= $matches[2].": ".$matches[1]."\n";
    }
    echo "</ul>\n</div>\n";
}

class table {
    var $row = 0;
    var $col = 0;
    var $colmax = 0;
    var $packages;
    var $params;
    var $thId;
    var $tdId;
    var $tableId;
    var $innerBorder = true;


    function setCol($input = "", $inputparams = "") {
        $this->col++;

        if($this->col > $this->colmax) $this->colmax = $this->col;

        $this->data[$this->row][$this->col]["data"] = $input;
        $this->data[$this->row][$this->col]["params"] = $inputparams;
    }

    function setRow()
    {
        $this->row++;
        $this->col = 0;
    }

    function show()
    {
        $h = "height=\"13\"";
        $w = "width=\"7\"";
        $colspan = $this->colmax;

        if (isset($this->summary)) {
            $summary = "summary=\"".$this->summary."\"";
        } else {
            $summary = '';
        }

        if (isset($this->tableId)) {
            $tableId = "id=\"".$this->tableId."\"";
        } else {
            $tableId = '';
        }

        echo "<table $tableId $summary cellspacing=\"0\" cellpadding=\"3\">\n";

        $k = 1;
        foreach ($this->data as $row) {
            echo '<tr>'."\n";

            $i = 0;
            foreach ($row as $col) {
            $class_tag = '';
            $style_tag = '';
            $class = '';
            $style = '';
            $empty_cells = '';

                if ($empty_cells > 1 && $i == 0) {
                    $empty_cells--;
                    $i++;
                    continue;
                }

                if (preg_match("/header/", $col["params"])) {
                    $start_tagname = "th id=\"".$this->thId."\"";
                    $end_tagname ='th';
                    if($this->innerBorder) $class = "border_bottom ";
                } elseif (empty($col["params"])) {
                    $style = '';
                    $start_tagname = "td id=\"".$this->tdId."\"";
                    $end_tagname ='td';
                } else {
                    $class = $col["params"];
                    $start_tagname = "td id=\"".$this->tdId."\"";
                    $end_tagname ='td';
                }

                $empty_cells = 0;
                while (empty($this->data[$k+$empty_cells][1]["data"]) && $empty_cells+$k <= count($this->data)) {
                    $empty_cells++;
                }

                if ($empty_cells > 1 && $i == 0) {
                    $span = " rowspan=\"$empty_cells\"";
                    $class.= " top_align";
                } elseif ($i == count($row)-1 && $i < $this->colmax-1) {
                    $colspan = $this->colmax - $i;
                    $span.= " colspan=\"$colspan\"";
                } else {
                    $span = '';
                }

                if ($i != $this->colmax-1 && !($i == count($row)-1 && $i < $this->colmax-1) && $this->innerBorder)
                    $class = "border_right $class";

                if (!empty($class)) {
                    $class_tag = " class=\"".trim($class)."\"";
                }

                if (!empty($style)) {
                    $style_tag = " style=\"".trim($style)."\"";
                }

                if (empty($col["data"])) $col["data"] = "&nbsp;";

                echo "\t".'<'.$start_tagname.$class_tag.$style_tag.$span.'>'.$col['data'].'</'.$end_tagname.'>'."\n";
                $i++;
            }
            echo "</tr>\n";
            $k++;
        }
        echo "</table>\n";
    }
}

?>
