#!/usr/bin/php-cgi
<?php
/**
 *---------------------------------------------------------------------------
 * /var/lib/asterisk/webinterface/htdocs/index.php
 *
 * Creation:     2005-04-16 fw
 * Last Update:  $Id: index.php 8552 2015-04-05 17:24:27Z holbru $
 *
 * Copyright (c) 2005-2006 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *----------------------------------------------------------------------------
 */

# error_reporting nur fuer ERROR, da sonst von NOTICE geflutet wird,
# bis das behoben ist.
//error_reporting(E_ERROR & E_WARNING);

global $debug;
$debug = false;
session_start();

header('refresh:15;');
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="de" xml:lang="de">
<head>
<title>Asterisk WebFrontend</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<link rel="stylesheet" href="stylesheet.css"/>

<?php
if (isset($_GET['module'])) {
    if (file_exists("./modules/{$_GET['module']}/{$_GET['module']}.css")) {
        echo "<link rel='stylesheet' type='text/css' href='./modules/{$_GET['module']}/{$_GET['module']}.css'/>";
    }
}
?>

</head>
<body>

<?php
include 'config.php';
include 'functions.inc.php';
include 'functionsOutput.inc.php';
include '/var/lib/asterisk/config/configParsing.php';
include '/var/lib/asterisk/config/consoleOutput.php';
include '/var/lib/asterisk/config/writeFunc.php';
include 'tapi.inc.php';

$handle = opendir('./modules');

while ($file = readdir ($handle)) {
   if ($file != "." &&
       $file != ".." &&
       is_dir('./modules/' . $file) &&
       $file != 'CVS') {

       $xml = new xml2array;
       $modules[$file] = $xml->parse(implode('', file('./modules/'.$file.'/'.$file.'.info')));
   }
}
asort($modules); //Alphabetisch sortieren
closedir($handle);

if (isset($_GET['module'])) {
    $akt_module = $_GET['module'];
} else {
    $akt_module = '';
}

list($VARS) = read_vars($configd);

// mysql_connect($dbhost, $dbuser, $dbpass);
// mysql_select_db($dbname);
?>

<div id="header">
  <div id="headright">
    <img src="images/asterisk.gif" border="0" alt="Asterisk-Logo" style="margin-right: 1em;"/>
    <img src="images/eisfair_logo_klein2.gif" border="0" alt="eisfair-Logo"/>
  </div>

  <div id="headleft">
    <h1>Asterisk Webinterface</h1>
    <em style="font-size: 10pt;">
      <strong>eisfair</strong> - the <strong>e</strong>asy <strong>i</strong>nternet <strong>s</strong>erver
    </em>
  </div>

</div>
<div id='nav'>
<ul id='menu'>

<?php
/**
 * Die Module aus dem $modules[] - Array in der Navigations-Leiste ausgeben
 */
foreach ($modules as $folder => $module) {
    /**
     * use the index.cgi wrapper for 'force-cgi-redirect'
     */
    echo "<li><a href='index.cgi?module=$folder&amp;file=index.php' title=\"".$module['MODULE']['DESC']['DATA']."\">";
    echo $module['MODULE']['NAME']['DATA'];
    echo '</a>'."\n".'</li>'."\n";

    if (isset($module['MODULE']['MENU'])) {
        echo "<ul id=\"submenu\">"."\n";

        if (is_array($module['MODULE']['MENU']['ITEM'][0])) {
            $arrayToWalk = $module['MODULE']['MENU']['ITEM'];
        } else {
            $arrayToWalk[0] = $module['MODULE']['MENU']['ITEM'];
        }

        foreach ($arrayToWalk as $attrib) {
            echo "<li>";
            if (isset($_GET['action']) &&
               ($_GET['action'] == $attrib['ACTION'] &&
                $_GET['file'] == $attrib['FILE'])) {

                $strongStart = '<strong>';
                $strongEnd = '</strong>';
            } else {
                $strongStart = '';
                $strongEnd = '';
            }

            /**
             * use the index.cgi wrapper for 'force-cgi-redirect'
             */
            echo $strongStart."<a href=\"index.cgi?module=".$folder."&amp;file=".$attrib['FILE']."&amp;action=".$attrib['ACTION']."\"
            title=\"".$attrib['DESC']."\">";
            echo $attrib['NAME'].'</a>'.$strongEnd.'</li>'."\n";
        }

        echo '</ul>'."\n";
        $arrayToWalk = '';
    }
}
?>

</ul>
</div>
<div id='contentbox'>
<div id='content'>

<?php

if (isset($_GET['module'])) {

    if (empty($error)) {
        $error = '';
    }

    /**
     * use the index.cgi wrapper for 'force-cgi-redirect'
     */
    $URI = $url.'/index.cgi?module='.$_GET['module'];

    /**
     * # Pruefe ob versucht wird in hoehere Verzeichnisebenen einzudringen
     */
    if (strpos($attrib['FILE'], '..') === false) {

        $path = $docroot.'/modules/'.$_GET['module'].'/'.$_GET['file'];

        /**
         * Pruefe, ob die angeforderte Datei existiert
         */
        if (is_file($path)) {
            include $path;
        } else {
            $error .= 'Moduldatei fehlt;error'."\n";
        }
    } else {
        $error .= 'Ung&uuml;ltige Zeichen in der URL;error'."\n";
    }

    if (!empty($error)) {
        msg($error);
    }

} else {
?>

<h2>Willkommen beim Asterisk Webinterface!</h2>

<?php
}
?>

<pre></pre>
</div>
</div>
</body>
</html>

<?php
// mysql_close();
?>
