<?php
/**
 *---------------------------------------------------------------------------
 * /var/lib/asterisk/webinterface/htdocs/modules/protocoll/index.php
 *
 * Creation:     2005-04-16 fw
 * Last Update:  $Id: index.php 8454 2015-03-14 20:29:55Z holbru $
 *
 * Copyright (c) 2005-2006 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *----------------------------------------------------------------------------
 */

require '/var/lib/asterisk/config/include/reverseLookup.php';

$rawLog = parseLog($callerlog);

function removeAreacode($number) {
    global $VARS;

    return preg_replace("#^" . $VARS["ASTERISK_AREA_CODE"] . "#", "", $number);
}

for ($i = 0; $i < count($rawLog); $i++) {
    if ($rawLog[$i]["lastapp"] == 'VoiceMailMain') {
        continue;
    }
    elseif (isset($_GET["action"]) && $_GET["action"] == "missed") {
        if ($rawLog[$i]["disposition"] == "ANSWERED" || $rawLog[$i]["disposition"] == "FAILED" || $rawLog[$i]["dcontext"] == "outgoing" || $rawLog[$i]["dcontext"] == "default") {
            $log[] = "";
            continue;
        }
    }
    elseif (isset($_GET["action"]) && $_GET["action"] == "outgoing") {
        if ($rawLog[$i]["dcontext"] == "incoming") {
            $log[] = "";
            continue;
        }
    }
    elseif (isset($_GET["action"]) && $_GET["action"] == "incoming") {
        if ($rawLog[$i]["dcontext"] == "outgoing" || $rawLog[$i]["dcontext"] == "default") {
            $log[] = "";
            continue;
        }
    }

    $log[] = $rawLog[$i];
}

#$log = array_reverse($log);

if (isset ($_GET["callID"])) { //soll Uebersicht angezeigt werden?
    $call = $log[$_GET["callID"]];

    if (empty ($call["src"]))
        $cid = "<em>unbekannt</em>";
    else
        $cid = $call["src"];

    $start = formatDateString(strtotime($call["start"]));
    $end = formatDateString(strtotime($call["end"]));
    if (empty ($call["billsec"]))
        $answer = "<em>Nicht abgehoben</em>";
    else {
        $answer = $call["duration"] - $call["billsec"];
        $answer .= " Sek.";
    }

    echo "<h2 style=\"margin-bottom: 2em;\">Anruf von <em>$cid</em> am $start</h2>";

    $t = new table;
    $t->tdId = "protocol";
    $t->thId = "protocolDetailed";
    $t->innerBorder = false;
    $t->setCol("Von:", "header");
    $t->setCol($cid);
    $t->setRow();
    $t->setCol("An:", "header");
    $t->setCol($call["dst"]);
    $t->setRow();
    $t->setCol("Anfang:", "header");
    $t->setCol($start);
    $t->setRow();
    $t->setCol("Ende:", "header");
    $t->setCol($end);
    $t->setRow();
    $t->setCol("Dauer:", "header");
    $t->setCol(date("i:s", $call["duration"]) . " Min.");
    $t->setRow();
    $t->setCol("Abgehoben nach:", "header");
    $t->setCol($answer);
    $t->setRow();
    $t->setCol("Aktion: ", "header");
    $t->setCol(getStatus($call));
    if (is_file("/var/spool/asterisk/monitor/" . $call["uniqueid"] . ".wav")) {
        $t->setRow();
        $t->setCol("Aufzeichnung: ", "header");
        $t->setCol("<embed autostart=\"false\" height=\"15\" src=\"/modules/protocol/play.php?id=" . $call["uniqueid"] . "\" />");
    }
    $t->show();
} else {

    /**
     * set defaults
     */
    $callback = '';
    $play = '';
    $callerIDNameStart = '';
    $callerIDNameEnd = '';
    $matches = '';
    $name = '';

    echo "<h2>Protokoll</h2>";

    if (isset($_GET["action"]) && $_GET["action"] == "missed") {
        $title = "Verpasste Anrufe";
    } elseif (isset($_GET["action"]) && $_GET["action"] == "outgoing") {
        $title = "Ausgegangene Anrufe";
    } elseif (isset($_GET["action"]) && $_GET["action"] == "incoming") {
        $title = "Eingegangene Anrufe";
    } else {
        $title = '';
    }

    echo "<h3>$title</h3>";

    $t = new table;
    $t->tdId = "protocol";
    $t->thId = "protocol";
    $t->innerBorder = false;
    $t->setCol("MSN", "header");
    $t->setCol("", "header");
    $t->setCol("CallerID", "header");
    $t->setCol("CbC", "header");
    $t->setCol("Uhrzeit", "header");
    $t->setCol("Status", "header");
    $t->setCol("Funktionen", "header");
    $t->setRow();

    $maxPerPage = 20;

    if (!isset ($_GET["scroll"]))
        $scroll = 0;
    else
        $scroll = $_GET["scroll"];

    for ($i = count($log) - $scroll * $maxPerPage; $i > count($log) - $scroll * $maxPerPage - $maxPerPage; $i--) {
        if (!isset ($log[$i]) || $log[$i] == "")
            continue;

        if ($log[$i]["dcontext"] == "outgoing" || $log[$i]["dcontext"] == "default") {
            $extNumber = removeAreacode($log[$i]["dst"]);
            $intNumber = removeAreacode($log[$i]["src"]);
            $arrow = "=&gt;";
            $direction = DIR_OUTGOING;

            if ($log[$i]["userfield"] == "preselection" && preg_match("#^010#", $extNumber)) {
                $cbc = "Manuell";
            }
            elseif (empty ($log[$i]["userfield"]) || $log[$i]["userfield"] == "preselection") {
                $cbc = "Presel.";
            } else
                $cbc = $log[$i]["userfield"];
        }
        elseif ($log[$i]["dcontext"] = "incoming") {
            $extNumber = removeAreacode($log[$i]["src"]);
            $intNumber = removeAreacode($log[$i]["dst"]);
            $arrow = "&lt;=";
            $direction = DIR_INCOMING;

            if ($log[$i]["userfield"] == "preselection" && preg_match("#^010#", $extNumber)) {
                $cbc = "Manuell";
            }
            elseif (empty ($log[$i]["userfield"])) {
                $cbc = "-";
            } else
                $cbc = $log[$i]["userfield"];
        }

        if ($extNumber == "" || $extNumber == "unknown") {
            $extNumber = "unbekannt";
        } else {
            $callback = " <a href='$URI&amp;file=callback.php&amp;callNumber=$extNumber'>W&auml;hlen</a>";
        }

        if ($direction == DIR_INCOMING) {
            if (preg_match('#"(.*)" <.*>#', $log[$i]["clid"], $matches)) {
                $name = $matches[1];
            }
            //            else {
            //                list ($name) = lookupName($extNumber);
            //            }
            if ($name) {
                $callerIDNameStart = "<acronym title=\"$name\">";
                $callerIDNameEnd = "</acronym>";
            }
        }

        $t->setCol($intNumber);
        $t->setCol($arrow);
        $t->setCol($callerIDNameStart . $extNumber . $callerIDNameEnd);
        $t->setCol($cbc);
        $t->setCol(date("Y-m-d H:i", strtotime($log[$i]["start"])));

        $status = getStatus($log[$i]);

        $t->setCol($status);

        $t->setCol("<a href=\"$URI&amp;file=index.php&amp;callID=$i&amp;action=show\">Details</a>$callback");

        $t->setRow();
  //      unset ($callback);
  //      unset ($play);
  //      unset ($callerIDNameStart);
  //      unset ($callerIDNameEnd);
  //      unset ($matches);
  //      unset ($name);
    }
    $t->show();

    echo "Seite ";

    if (empty($_GET['scroll'])) {
        $_GET['scroll'] = 0;
    }

    if (isset($_GET["action"])) {
        $action = $_GET['action'];
    } else {
        $action = '';
    }

    $tmp = $_GET["scroll"] - 1;
    if ($_GET["scroll"] > 1)
        echo "<a href=\"$URI&amp;file=index.php&amp:action=" . $action . "&amp;scroll=$tmp\"><strong>&laquo;</strong></a> ";

    for ($i = 0; $i < count($log) - 1; $i += $maxPerPage) {
        $page = $i / $maxPerPage +1;

        if (($_GET["scroll"] + 1) == $page) {
            $strongStart = "<strong>";
            $strongEnd = "</strong>";
        } else {
           $strongStart = '';
           $strongEnd = '';
   //         unset ($strongStart);
   //         unset ($strongEnd);
        }

        $tmp = $page -1;

        echo "<a href=\"$URI&amp;file=index.php&amp;action=" . $action . "&amp;scroll=$tmp\">" . $strongStart . $page . $strongEnd . "</a> ";
    }

    $tmp = $_GET["scroll"] + 1;

    if ($_GET["scroll"] < $page -1)
        echo "<a href=\"$URI&amp;file=index.php&amp;action=" . $action. "&amp;scroll=$tmp\"><strong>&raquo;</strong></a>";
}
?>
