<?php
/**
 *---------------------------------------------------------------------------
 * /var/lib/asterisk/webinterface/htdocs/tapi.inc.php
 *
 * Creation:     2005-04-16  fw
 * Last Update:  $Id: tapi.inc.php 8393 2015-02-16 21:50:50Z holbru $
 *
 * Copyright (c) 2005-2006 Fabian Wolter, fabian(at)eisfair(dot)org
 * Copyright (c) 2014-2019 Holger Bruenjes, holgerbruenjes(at)gmx(dot)net
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *---------------------------------------------------------------------------
 */

function TAPIput($data)
{
    global $TAPIfp;

    fwrite($TAPIfp, $data);

  //  #echo "IN:  $data";
}

function TAPIget()
{
    global $TAPIfp;

    $data = fgets($TAPIfp, 4096);

 //   #echo "OUT: $data";

    return $data;
}

function TAPIConnect($host, $port, $username, $secret)
{
    global $TAPIfp;

    $TAPIfp = fsockopen($host, $port);
    $data = str_replace("\n", "", TAPIget());

    if (strpos($data, "Asterisk Call Manager/1.0") !== false) {
    } else {
        return false;
    }

    TAPIput("Action: Login\r\n");
    TAPIput("Username: ".$username."\r\n");
    TAPIput("Secret: ".$secret."\r\n\r\n");

    $data = ".";
    while ($data != "") {
        $data = TAPIget();
        $data = trim(str_replace("\n", "", $data));
        $data = trim(str_replace("\r", "", $data));
        if (strpos($data, "Success") !== false) {
            $login = true;
        }
    }

    TAPIput("Action: Events\r\n");
    TAPIput("EventMask: off\r\n\r\n");
    $data = ".";
    while ($data != "") {
        $data = TAPIget();
        $data = trim(str_replace("\n", "", $data));
        $data = trim(str_replace("\r", "", $data));
        if (strpos($data, "Success") !== false) {
            $login = true;
        }
    }

    if (!$login) {
        return false;
    } else {
        return true;
    }
}

function TAPIOriginate($ph, $externalNumber)
{
    $context = "outgoing";
    $exten = $externalNumber;
    $priority = 1;
    $callerIDName = "Asterisk Telefonserver";

    TAPIput("Action: Originate\r\n");
    TAPIput("Channel: ".$ph->getDialCmd()."\r\n");
    TAPIput("Async: true\r\n");
    TAPIput("Context: ".$context."\r\n");
    TAPIput("Exten: ".$exten."\r\n");
    TAPIput("CallerID: $callerIDName <".$ph->getMsn().">\r\n");
    TAPIput("Priority: ".$priority."\r\n\r\n");

    $data = ".";
    while ($data != "") {
        $data = TAPIget();
        $data = trim(str_replace("\n", "", $data));
        $data = trim(str_replace("\r", "", $data));
        if (strpos($data, "Sucess:") !== false) {
            return true;
        } else {
            return false;
        }
    }
}
?>